$(document).ready(function () {
    filtry();
    
});

var filtry = function () {
    filtryPracownika();
    filtryObecnosci();
    zdjecia();
    listaTooltip();
};

var filtryPracownika = function () {
    $('div select.pracownicy').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        maxHeight: getH('.pracownicy'),
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '')
            return result;
        },
        optionClass: function () { return 'pracownik'; },
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        onChange: function () {
            $.fn.yiiGridView.update('obecnosc-grid', buildJSON());
        }
    });
};

var getH = function (selector) {
    return window.innerHeight - ($(selector).offset().top + ($(selector).height() ));
};

var filtryObecnosci = function () {

    $('div select.obecnosc').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        maxHeight: getH('.obecnosc'),
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '')
            return result;
        },
        onChange: (function () {
            $.fn.yiiGridView.update('obecnosc-panel', buildJSON());
        })
    });

    var statusItemsCollection = $('span div ul li a label input');

    for (var a = 0; a < statusItemsCollection.length; a++) {
        if (statusItemsCollection[a].value == '0')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:red; color:white;');
        if (statusItemsCollection[a].value == '1')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:green; color:white;');
        if (statusItemsCollection[a].value == '2')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:orange; color:white;');
        if (statusItemsCollection[a].value == '3')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:gray; color:white;');
    }
};

var buildJSON = function () {
    
    var pracownicy = [];
    var obec = [];

    var it = 0;
    $('div select.pracownicy option').each(function (key, value) {
        if (value.selected === true) {
            if ($(value)) {
                pracownicy[it] = $(value).val();
                it++;
            }
        };
    });

    it = 0;
    $('div select.obecnosc option').each(function (key, value) {
        if (value.selected === true) {
            obec[it] = $(value).val();
            it++;
        };
    });
    validateFilters(pracownicy,obec);
    var result = {
        data: {
            ListaObecnosci: {
                uid: pracownicy,
                obecny: obec
            }
        }
    };

    return result;
};

var validateFilters = function (pracownicy, status) {
    if (
        pracownicy.length == 0
        || status.length == 0
    ) {
        var ajax = $.ajax({
            url: '/urlopy/rcp/clearFilters',
            type: 'GET',
            success: function () {
                return true;
            },
            failt: function () {
                return false;
            }
        });
    }
};

var zdjecia = function () {

    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true')
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-container', 'body');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<img src=\"' + data + '\"></img>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }
    var ajax = null;
    $('[data-toggle=\"tooltip\"]').tooltip();
    $('td div span div ul li.pracownik a').on({
        mouseenter: function () {
            var obj = $(this);
            var id = $(this).children('label').children('input').val();
            id = id.split(';');
            if (id.length > 1)
                id = id[1];
            else
                id = id[0];
            if ($.isNumeric(id)) {
                if (id != undefined) {
                    if (obj.attr('data-html') == undefined) {
                        ajax = $.ajax({
                            url: '/urlopy/site/getAvatar',
                            type: 'GET',
                            dataType: 'json',
                            data: {
                                'id': id
                            },
                            success: (function (data) {
                                datatitle(obj, data, function () {
                                    htmltrue(obj, function () {
                                        dataplacement(obj, function () {
                                            datatoggle(obj, function () {
                                                maketooltip(obj);
                                            });
                                        });
                                    });
                                });
                            }),
                            fail: (function (data) {
                                console.log('ERROR: Avatar not loaded;');
                            })
                        });
                    }
                }
            }
        },
        mouseleave: function () {
            if (ajax)
                ajax.abort();
        }
    });
};

var listaTooltip = function () {
    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true')
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-container', '#content');
        obj.attr('data-template', '<div class="tooltip" role="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner col-xs-12" style="max-height:200px; min-width:300px;"></div></div>');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<div class="col-xs-6"><img src=\"' + data.img + '\"></img></div><div class="col-xs-1"></div><div class="col-xs-5"><p>Ostatnia aktywność: ' + data.lastActivity +'</p></div>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }
    var ajax = null;
    $('[data-toggle=\"tooltip\"]').tooltip();
    $('.fa-user.fa-2x.lista-tooltip').on({
        mouseenter: function () {
            var obj = $(this);
            var id = $(this).attr('id');
            if ($.isNumeric(id)) {
                if (id != undefined) {
                    if (obj.attr('data-html') == undefined) {
                        ajax = $.ajax({
                            url: '/urlopy/rcp/getTooltip',
                            type: 'GET',
                            dataType: 'json',
                            data: {
                                'id': id
                            },
                            success: (function (data) {
                                datatitle(obj, data, function () {
                                    htmltrue(obj, function () {
                                        dataplacement(obj, function () {
                                            datatoggle(obj, function () {
                                                maketooltip(obj);
                                            });
                                        });
                                    });
                                });
                            }),
                            fail: (function (data) {
                                console.log('ERROR: Avatar not loaded;');
                            })
                        });
                    }
                }
            }
        },
        mouseleave: function () {
            if (ajax)
                ajax.abort();
        }
    });
}

var presencePdfList = function () {
    var link = '/urlopy/rcp/PresenceListPdf';
    
};