$(document).ready(function () {
    Loading.show();
    getData();
    selectProperMonth();
    var ajax = 0;
    $('#visioDrop').on('change', function () {
        var vals = [];
        vals = $('#visioDrop').val();
        if ($.inArray("0", vals) === -1) {
            $('.days').show();
        } else {
            $('.days').hide();
        }
        if ($.inArray("1", vals) === -1) {
            $('.rcp').show();
        } else {
            $('.rcp').hide();
        }
        if ($.inArray("2", vals) === -1) {
            $('.summary').show();
        } else {
            $('.summary').hide();
        }
    });
    $('#visioDrop').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableClickableOptGroups: true,
        enableFiltering: true,
        buttonWidth: '90%',
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,

        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        }
    });
    $('#pracownicy').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableClickableOptGroups: true,
        enableFiltering: true,
        buttonWidth: '90%',
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,
        optionClass: function () {
            return 'pracownik';
        },
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        onChange: function () {
            Loading.show();
            if (ajax != 0)
                ajax.abort();
            ajax = getData();
        }
    });
});

var getData = function () {
    var ajax = $.ajax({
        type: 'GET',
        dataType: 'json',
        data: {date: $('#hiddenDate').val(), userid: $('#pracownicy').val()},
        url: document.location.origin + '/urlopy/rcp/getDaysList',
        success: function (data) {
            $('[data-toggle="popover"]').popover('destroy');
            if (data != null)
                drawTable(data);
            Loading.hide();
        },
        error: function (err) {
            console.log(err);
        }
    });
    return ajax;
};

var selectProperMonth = function () {
    var ajax = $.ajax({
        type: 'GET',
        dataType: 'json',
        url: document.location.origin + '/urlopy/rcp/getRCPTabela',
        success: function (data) {
            data = data.split("-");
            var month = data[1];
            $('[value="' + month + '"]').addClass('btn-primary');
        },
        error: function (err) {
            console.log(err);
        }
    });
};

var drawTable = function (data) {
    var table = buildTable(data);
    $('#tableContainer').html(table);
    listaTooltip();
    listaPopover();
    Loading.hide();

};

var buildTable = function (data) {
    var table = '<table style="width:100%; min-width:95%">';
    table += buildRows(data);
    table += '</table>';
    return table;
};

var buildRows = function (data) {
    var row = '';
    var days = 0;
    for (var key in data[0].days) {
        days++;
    }
    row += '<thead>';
    row += '<tr>';
    row += '<th>Lp.</th>';
    row += '<th>Pracownik</th>';

    for (var key in data[0].days) {
        row += '<th class="days">' + key + '</th>';
    }
    row += '<th class="rcp" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Przepracowanych godzin (RCP)" style="min-width: 31px;max-width: 31px; border-left: 3px solid;">RCP</th>';
    row += '<th class="summary" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Urlopy (U)" style="min-width: 31px;max-width: 31px;">U</th>';
    row += '<th class="summary" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Choroby (Ch)" style="min-width: 31px;max-width: 31px;">Ch</th>';
    row += '<th class="summary" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Razem zarejestrowanch godzin (RCP+U+Ch)" style="min-width: 31px;max-width: 31px; ">RG</th>';
    row += '<th class="summary" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Do przepracowania godzin (N-U-Ch)" style="min-width: 31px;max-width: 31px; border-left: 3px solid;">DP</th>';
    row += '<th class="summary" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Norma pracy (N)" style="min-width: 31px;max-width: 31px;">N</th>';
    row += '</tr>';
    row += '</thead>';
    row += '<tbody>';
    for (var i = 0; i < data.length; i++) {
        row += '<tr>';
        row += buildCells(data[i], i + 1);
        row += '</tr>';
    }
    row += '</tbody>';
    return row;
};

var monthClick = function (e) {
    $('.buttonMonth').removeClass('btn-primary');
    Loading.show();
    e.addClass('btn-primary');
};

var buildCells = function (model, i) {
    var cells = '';
    cells += buildCell(model.user, i);
    for (var key in model.days) {
        cells += buildDayCell(model.days[key], model.userid, key);
    }
    cells += buildSummaryCell(model);
    return cells;
};

var tdStyle = 'min-width:25px; max-width:25px; border: 1px solid #303030; text-align: center; ';
var buildDayCell = function (callback, userid, day) { //sob, niedziela wyroznic,  ile godzin w środku, wrzucac wnioski
    var cells = '';
    cells += '<td class="days" popover-id="' + userid + '" popover-name="' + day + '" style="background-color:' + callback.color + '; ' + tdStyle;
    if (callback.popover == '') {
        cells += 'font-size: 1em;';
        if (callback.text != '')
            cells += '">' + callback.text;
        else
            cells += ' cursor:pointer;" data-toggle="popover" id="emptyCell" >';
    }
    if (callback.popover == 'false')
        cells += ' cursor:pointer; ' + (('<i class="fa fa-tags" aria-hidden="true"></i>' == callback.text) ? 'font-size:1.1em;' : 'font-size:10px;') + '" data-toggle="popover">' + callback.text;
    if (callback.popover == 'true')
        cells += ' cursor:pointer; font-size:1.1em;" data-toggle="popover"><i class="fa fa-tags" aria-hidden="true"></i>';
    cells += '</td>';
    return cells;
};

var buildCell = function (callback, i) {
    var cells = '';
    cells += '<td style="border: 1px solid #303030; "><b>';
    cells += i + '. ';
    cells += '</b></td>';
    cells += '<td style="border: 1px solid #303030; "><b>';
    cells += callback;
    cells += '</b></td>';
    return cells;
};

var buildSummaryCell = function (callback) {
    var cells = '';

    cells += '<td class="rcp" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Rozpisanych: ' + callback.made + 'h<br/>Do rozpisania: ' + callback.toMake + 'h" style="border: 1px solid #303030; text-align: right; background-color: #e6f2ff;  border-left: 3px solid; font-size: 10px;">';
    cells += callback.summary + ' ';
    cells += '</td>';
    cells += '<td class="summary" style="border: 1px solid #303030; text-align: right; background-color: #e6f2ff; font-size: 10px;">';
    cells += callback.sum.holidays;
    cells += '</td>';
    cells += '<td class="summary" style="border: 1px solid #303030; text-align: right; background-color: #e6f2ff; font-size: 10px;">';
    cells += callback.sum.sickDays;
    cells += '</td>';
    cells += '<td class="summary" style="border: 1px solid #303030;  text-align: right; background-color: lightblue; font-size: 10px;">';
    cells += callback.sum.razem;
    cells += '</td>';
    cells += '<td class="summary" style="border: 1px solid #303030; border-left: 3px solid; text-align: right; background-color: lightblue;  font-size: 10px;">';
    cells += callback.sum.toWork + ' ';
    cells += '</td>';
    cells += '<td class="summary" style="border: 1px solid #303030; text-align: right; background-color: #e6f2ff; font-size: 10px;">';
    cells += callback.sum.fullWorkTime;
    cells += '</td>';

    return cells;
};

var listaTooltip = function () {
    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true')
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-placement', function () {
            var position = $(obj).position();

            if (position.top < 110) {
                return "bottom";
            }

            return "top";
        });
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-template', '<div class="tooltip" role="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner col-xs-12" style="max-height:200px; min-width:300px;"></div></div>');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<div class="col-xs-6"><img src=\"' + data.img + '\"/></div><div class="col-xs-1"></div><div class="col-xs-5"><p>Ostatnia aktywność: ' + data.lastActivity + '</p></div>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }

    var ajax = null;

    $('[data-toggle=\"tooltip\"]').tooltip();
    $('[rel="tooltip"]').tooltip();

    $('.fa-user.fa-lg.lista-tooltip').on({
        mouseenter: function () {
            var obj = $(this);
            var id = $(this).attr('id');
            if ($.isNumeric(id)) {
                if (id != undefined) {
                    if (obj.attr('data-html') == undefined) {
                        ajax = $.ajax({
                            url: '/urlopy/rcp/getTooltip',
                            type: 'GET',
                            dataType: 'json',
                            data: {
                                'id': id
                            },
                            success: (function (data) {
                                datatitle(obj, data, function () {
                                    htmltrue(obj, function () {
                                        dataplacement(obj, function () {
                                            datatoggle(obj, function () {
                                                maketooltip(obj);

                                            });
                                        });
                                    });
                                });
                            }),
                            fail: (function (data) {
                                console.log('ERROR: Avatar not loaded;');
                            })
                        });

                    }
                }
            }
        },
        mouseleave: function () {
            if (ajax)
                ajax.abort();
        }
    });
}

var listaPopover = function () {
    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true');
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'popover');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-template', '<div class="popover"><div class="arrow"></div><div class="popover-content"></div></div>');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-content', data);
        callback();
    }

    function maketooltip(obj) {
        obj.popover('show');
    }

    var ajax = null;
    $('[data-toggle="popover"]').popover({
        viewport: '#tableContainer', container: 'body', html: true, placement: function (context, source) {
            var position = $(source).position();

            if (position.left > 515) {
                return "left";
            }

            if (position.left < 515) {
                return "right";
            }

            if (position.top < 110) {
                return "bottom";
            }

            return "top";
        }
    });
    $('[data-toggle="popover"]').on('click', function () {
        var obj = $(this);
        var userid = obj.attr('popover-id');
        var day = obj.attr('popover-name');
        var date = $('#hiddenDate').val();
        if (day != undefined && userid != undefined) {
            if (obj.attr('data-html') == undefined) {
                ajax = $.ajax({
                    url: '/urlopy/rcp/getPopover',
                    type: 'GET',
                    dataType: 'json',
                    data: {
                        'userid': userid,
                        'day': day
                    },
                    success: (function (data) {
                        var addTable = '<table><tr><td><h4 style="font-size:15px !important;">Dodaj</h4></td>' +
                            '<td>' +
                            '<a onclick="Loading.show()"' +
                            'rel="tooltip" data-original-title="Zapis RCP"' +
                            'href="/urlopy/rcp/special?userid=' + userid + '&date=' + date + '&day=' + day + '">' +
                            '<i style="color:black;margin-left:5px; ;" class="fa ' +
                            'fa-calendar-plus-o" ' +
                            'aria-hidden="true"></i></a>' +
                            '<a onclick="Loading.show()" ' +
                            'rel="tooltip" data-original-title="Zdarzenie"' +
                            'href="/urlopy/wniosek/special?userid=' + userid + '&date=' + date + '&day=' + day + '"><i style="color:black;' +
                            'margin-left:4px; ' +
                            'margin-right:4px;" ' +
                            'class="fa fa-clock-o" aria-hidden="true"></i></a>'+
                            '</td></tr></table>';
                        if (data.length <= 29) {
                            data = addTable;
                        } else {
                            data = addTable + data;
                        }
                        datatitle(obj, data, function () {
                            htmltrue(obj, function () {
                                dataplacement(obj, function () {
                                    datatoggle(obj, function () {
                                        maketooltip(obj);

                                    });
                                });
                            });
                        });

                    }),
                    fail: (function (data) {
                        console.log('ERROR: Avatar not loaded;');
                    })
                });
            }

        } else {

        }
        return true;
    });
}