$(document).ready(function () {
    filtry();
    exportRcp();
    selectProperMonth();
    zdjecia();
});

var filtry = function () {
    filtryPracownika();
    filtryStatus();
    allSelection();
};

var getH = function (selector) {
    return window.innerHeight - ($(selector).offset().top + ($(selector).height() ));
};

var monthClick = function (e) {
    $('.buttonMonth').removeClass('btn-primary');
    e.addClass('btn-primary');
};

var selectProperMonth = function () {
    var ajax = $.ajax({
        type: 'GET',
        dataType: 'json',
        url: document.location.origin + '/urlopy/userSet/getUserViewDate',
        success: function (data) {
            data = data.split("-");
            var month = data[1];
            $('[value="'+month+'"]').addClass('btn-primary');

        },
        error: function (err) {
            console.log(err);
        }
    });
};

var exportRcp = function () {

    $('#rozlicz_submit').on('click', function () {
        location.reload();
    });
    $('#export').on('click', function () {
        Loading.show();
        var ajax = $.ajax({
            type: 'GET',
            data: { users: $.fn.yiiGridView.getChecked('RCPLista-grid', 'someChecks'), date: $('#hiddenMonth').val() },
            url: document.location.origin + '/urlopy/rcp/export',
            success: function (data) {
                Loading.hide();
                $('#eksportModal').modal('toggle');
                $('#eksportModal div.modal-body').append('Zakończono export,<br/> przejdź teraz do Symfonii aby wczytać zapisy RCP.');
                $.fn.yiiGridView.update('RCPLista-grid');
            },
            error: function (data) {
                Loading.hide();
                window.alert('Zaznacz pracownika/ów aby wykonać eksport');
            },
        });
    });

    $('#exportHour').on('click', function () {
        Loading.show();
        var ajax = $.ajax({
            type: 'GET',
            data: { users: $.fn.yiiGridView.getChecked('RCPLista-grid', 'someChecks'), date: $('#hiddenMonth').val() },
            url: document.location.origin + '/urlopy/rcp/exporthours',
            success: function (data) {
                Loading.hide();
                $('#eksportModal').modal('toggle');
                $('#eksportModal div.modal-body').append('Zakończono export,<br/> przejdź teraz do Symfonii aby wczytać zapisy RCP.');
                $.fn.yiiGridView.update('RCPLista-grid');
            },
            error: function (data) {
                Loading.hide();
                //window.alert('Zaznacz pracownika/ów aby wykonać eksport');
            },
        });
    });

};

var filtryPracownika = function () {
    $('div select.pracownicy').multiselect({
        includeSelectAllOption: true,
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        maxHeight: getH('.pracownicy'),
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '')
            return result;
        },
        optionClass: function () { return 'pracownik'; },
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        onChange: function () {
            $.fn.yiiGridView.update('RCPLista-grid', buildJSON());
        }
    });
};

var filtryStatus = function () {

    $('div select.status').multiselect({
        includeSelectAllOption: true,
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '')
            return result;
        },
        onChange: (function () {
            $.fn.yiiGridView.update('RCPLista-grid', buildJSON());
        }),
    });

    var statusItemsCollection = $('span div ul li a label input');

    for (var a = 0; a < statusItemsCollection.length; a++) {
        if (statusItemsCollection[a].value == 'brak_zapisow')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:lightgray; ');
        if (statusItemsCollection[a].value == 'czesciowo')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:#ffd27f; ');
        if (statusItemsCollection[a].value == 'rozpisany')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:lightgreen; ');
        if (statusItemsCollection[a].value == 'nierozpisany')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:pink; ');
    }
};

var allSelection = function () {
    $('a.multiselect-all').on('click', function () {
        var html = $('div.btn-group.open button span.multiselect-selected-text').html();
        var openParent = $('div.btn-group.open').parent();
        var openSelect = $(openParent).children('select');
        var type = $(openSelect).attr("class").split(' ');
        var selectorType = '';
        if (type){
            selectorType ='div select.'+ type[type.length-1];
        }
        if (html.indexOf('Wszystkie') === 0) {
            $(selectorType).multiselect('deselectAll',false);
        } else {
            $(selectorType).multiselect('selectAll',false);
        }
    });
}

var buildJSON = function () {

    var pracownicy = [];

    var it = 0;
    $('div select.pracownicy option').each(function (key, value) {
        if (value.selected === true) {
            if ($(value)) {
                pracownicy[it] = $(value).val();
                it++;
            }
        };
    });

    //validateFilters(rodzaj,status);

    var result = {
        data: {
            RCPPodsumowanie: {
                uid: pracownicy
            }
        }
    };
    return result;
};

var zdjecia = function () {

    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true');
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-container', 'body');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<img src=\"' + data + '\"></img>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }
    var ajax = null;
    $('[data-toggle=\"tooltip\"]').tooltip();
    $('td div span div ul li.pracownik a').on({
        mouseenter: function () {
            var obj = $(this);
            var id = $(this).children('label').children('input').val();
            id = id.split(';');
            if (id.length > 1)
                id = id[1];
            else
                id = id[0];
            if (id !== undefined) {
                if ($.isNumeric(id) ) {
                    if (obj.attr('data-html') == undefined) {
                        ajax = $.ajax({
                            url: '/urlopy/site/getAvatar',
                            type: 'GET',
                            dataType: 'json',
                            data: {
                                'id': id
                            },
                            success: (function (data) {
                                datatitle(obj, data, function () {
                                    htmltrue(obj, function () {
                                        dataplacement(obj, function () {
                                            datatoggle(obj, function () {
                                                maketooltip(obj);
                                            });
                                        });
                                    });
                                });
                            }),
                            fail: (function (data) {
                                console.log('ERROR: Avatar not loaded;');
                            })
                        });
                    }
                }
            }
        },
        mouseleave: function () {
            if (ajax)
                ajax.abort();
        }
    });
};

var presenceList = function () {
        var arguments = $.fn.yiiGridView.getChecked('RCPLista-grid', 'someChecks');
        var link = '/urlopy/rcp/presencelist';
        $('#presence').attr('href',link.concat('?arrayIds=',arguments));
        if(arguments.length === 0){
            window.alert('Zaznacz pracownika by wygenerować listę obecności');
            return false;
        }
};