$(document).ready(function () {
    mainForm();
    childForm();
});

var mainForm = function () {
    checkSums();

    submitMainForm();
    disableMainForm();
    manageParam1();
    manageParam2();
    manageValues();
    $(document).keypress(function (e) {
        if (e.which == 13) {
            if ($('#mainFormSubmit').prop('disabled') == false)
                $('#mainFormSubmit').click();
        }
    });
    manageDictionaryMainForm();
};

var childForm = function () {
    manageParam1ChildForm();
    manageParam2ChildForm();
    manageValuesChildForm();
};

var manageParam1ChildForm = function () {
    $('.param1').on('change', function (e) {
        var id = $(e.target).prop('id');
        $('#' + id + '.param2').empty();
        $('#' + id + '.value1').val('');
        $('#' + id + '.value2').val('');
        $('#' + id + '.value2').prop('disabled', true);
        $('#' + id + '.value1').prop('disabled', true);
        if ($('#' + id + '.param1').val() != '') {
            var ajax = $.ajax({
                url: document.location.origin + '/urlopy/rcp/getParam2List',
                dataType: 'json',
                type: 'GET',
                data: {
                    rcpid: $('#rcpid').val(),
                    param1: $('#' + id + '.param1').val()
                },
                success: function (data) {
                    $('#' + id + '.param2').html('');
                    $('#' + id + '.param2').append('<option value>Wybierz...</option>')
                    $('#' + id + '.param2').prop('disabled', false);
                    for (var i = 0; i < data.length; i++)
                        $('#' + id + '.param2').append('<option value="' + data[i] + '">' + data[i] + '</option>');
                }
            });
        }
    });
};

var manageParam2ChildForm = function () {
    $('.param2').on('change', function (e) {
        var id = $(e.target).prop('id');
        $('#' + id + '.value1').val('');
        $('#' + id + '.value1').prop('disabled', false);
        $('#' + id + '.value2').val('');
        $('#' + id + '.value2').prop('disabled', false);
    });
};

var manageValuesChildForm = function () {
    $('.value1').on('change', function (e) {

        var id = $(e.target).prop('id');
        if ($('#' + id + '.value1').val() !== '00:00') {
            var value1TimeString = $('#' + id + '.value1').val();
            if ($(e.target).val() != '') {
                var ajax = $.ajax({
                    url: document.location.origin + '/urlopy/rcp/checkSum',
                    dataType: 'json',
                    type: 'GET',
                    data: {
                        rcpid: $('#rcpid').val(),
                        time: {dayTime:value1TimeString},
                        id: id,
                        type: 'value1'
                    },
                    success: function (data) {
                        if (data.remind < 0)
                            $('#remind').html('<b style="color:red;">rozpisano za dużo o: ' + data.time + '</b>');
                        else {
                            if (data.remind == 0)
                                $('#remind').html('<b style="color:green;">pozostało do rozpisania: ' + data.time + ' </b>');
                            else
                                $('#remind').html('<b>pozostało do rozpisania: ' + data.time + ' </b>');

                            var ajax = $.ajax({
                                url: document.location.origin + '/urlopy/rcp/ajaxUpdateParametr',
                                type: 'GET',
                                data: {
                                    id: id,
                                    rcpid: $('#rcpid').val(),
                                    dictionary: $('#' + id + '.dictionary').val(),
                                    param1: $('#' + id + '.param1').val(),
                                    param2: $('#' + id + '.param2').val(),
                                    value1: $('#' + id + '.value1').val() ? $('#' + id + '.value1').val() : '00:00:00',
                                    value2: $('#' + id + '.value2').val() ? $('#' + id + '.value2').val() : '00:00:00',
                                },
                                success: function () {
                                    $.fn.yiiGridView.update('parametry-grid');
                                }
                            });
                        }
                    }
                });
            }
        }
    });

    $('.value2').on('change', function (e) {
        var id = $(e.target).prop('id');
        if ($('#' + id + '.value2').val() != '00:00') {
            var value2TimeString = $('#' + id + '.value2').val();
            if ($(e.target).val() != ''){
                var ajax = $.ajax({
                    url: document.location.origin + '/urlopy/rcp/checkSum',
                    dataType: 'json',
                    type: 'GET',
                    data: {
                        rcpid: $('#rcpid').val(),
                        time: {nightTime:value2TimeString},
                        id: id,
                        type: 'value2'
                    },
                    success: function (data) {

                        if (data.remind < 0)
                            $('#remind').html('<b style="color:red;">rozpisano za dużo o: ' + data.time + '</b>');
                        else {
                            if (data.remind == 0)
                                $('#remind').html('<b style="color:green;">pozostało do rozpisania: ' + data.time + ' </b>');
                            else
                                $('#remind').html('<b>pozostało do rozpisania: ' + data.time + ' </b>');

                            var ajax = $.ajax({
                                url: document.location.origin + '/urlopy/rcp/ajaxUpdateParametr',
                                dataType: 'json',
                                type: 'GET',
                                data: {
                                    id: id,
                                    rcpid: $('#rcpid').val(),
                                    dictionary: $('#' + id + '.dictionary').val(),
                                    param1: $('#' + id + '.param1').val(),
                                    param2: $('#' + id + '.param2').val(),
                                    value1: $('#' + id + '.value1').val() ? $('#' + id + '.value1').val() : '00:00:00',
                                    value2: $('#' + id + '.value2').val() ? $('#' + id + '.value2').val() : '00:00:00',
                                },
                                success: function () {
                                    $('#parametry-grid').yiiGridView('update');
                                }
                            });
                        }
                    }
                });
            }
        }
    });
};

var submitMainForm = function () {
    var RCPid = $('#rcpid');
    var param1 = $('#param1');
    var param2 = $('#param2');

    $('#mainFormSubmit').on('click', function () {
        $('#mainFormSubmit').attr('disabled','disabled');
        var value1 = $('#value1').val();
        var value2 = $('#value2').val();
        var ajax = $.ajax({
            url: document.location.origin + '/urlopy/rcp/checkSum',
            dataType: 'json',
            type: 'GET',
            data: {
                rcpid: $('#rcpid').val(),
                time: {dayTime:value1, nightTime:value2},
            },
            success: function (data) {
                console.log(data);
                if (data.remind < 0){
                    $('#remind').html('<b style="color:red;">rozpisano za dużo o: ' + data.time + '</b>');
                    check();}
                else if (data.remind === 0) {
                    $('#remind').html('<b style="color:green;">pozostało do rozpisania:  ' + data.time + ' </b>');
                    $.ajax({
                        url: document.location.origin + '/urlopy/rcp/ajaxCreateParametr',
                        type: 'GET',
                        data: {
                            rcpid: $('#rcpid').val(),
                            param1: $('#param1').val(),
                            param2: $('#param2').val(),
                            value1: ($('#value1').val()) ? $('#value1').val() + ':00' : '00:00:00',
                            value2: ($('#value2').val()) ? $('#value2').val() + ':00' : '00:00:00',
                            dictionary: $('#dictionary').val()
                        },
                        success: function (data) {
                            check();
                            param1.val('');
                            param2.val('');
                            $('#value1').val('');
                            $('#value2').val('');
                            $('#dictionary').val('');
                            checkSums();
                            disableMainForm();
                        },
                        error:function (data) {
                            console.log('Problem Occured');
                        },
                        done: function (data) {
                            console.log('am i here??');
                        },
                    });
                } else {
                    $('#remind').html('pozostało do rozpisania: ' + data.time);

                    $.ajax({
                        url: document.location.origin + '/urlopy/rcp/ajaxCreateParametr',
                        type: 'GET',
                        data: {
                            rcpid: RCPid.val(),
                            param1: param1.val(),
                            param2: param2.val(),
                            value1: ($('#value1').val()) ? $('#value1').val() + ':00' : '00:00:00',
                            value2: ($('#value2').val()) ? $('#value2').val() + ':00' : '00:00:00',
                            dictionary: $('#dictionary').val()
                        },
                        success: function (data) {
                            check();
                            param1.val('');
                            param2.val('');
                            $('#value1').val('');
                            $('#value2').val('');
                            $('#dictionary').val('');
                            checkSums();
                            disableMainForm();
                        },
                        error: function (data) {
                            console.log('Problem Occured');
                        }
                    });
                }
            }
        });

    });
};
function check() {
    $('#yw0').yiiGridView('update',{url: document.location.origin + '/urlopy/rcp/rozpisz/'+$('#rcpid').val()});
}

var manageDictionaryMainForm = function () {
    $('#dictionary').on('change', function () {
        disableMainForm();
        $('#param1').prop('disabled', false);
        var ajax = $.ajax({
            url: document.location.origin + '/urlopy/rcp/isFromWzorzec',
            dataType: 'json',
            type: 'GET',
            data: {
                rcpid: $('#rcpid').val(),
                value: $('#dictionary').val(),
            },
            success: function (data) {
                console.log(data);
                if (data.is == true) {
                    $('#param1').html('');
                    $('#param1').append('<option value>Wybierz...</option>');
                    for (var key in data.rowid) {
                        $('#param1').append('<option value="' + data.rowid[key] + '">' + data.rowid[key] + '</option>');
                    }
                } else {
                    var ajax = $.ajax({
                        url: document.location.origin + '/urlopy/rcp/getAjaxParam1List',
                        dataType: 'json',
                        type: 'GET',
                        data: {
                            rcpid: $('#rcpid').val(),
                        },
                        success: function (data) {
                            $('#param1').html('');
                            $('#param1').append('<option value>Wybierz...</option>');
                            for (var key in data) {
                                $('#param1').append('<option value="' + data[key] + '">' + data[key] + '</option>');
                            }
                        }
                    });
                }
            }
        });
    });
};

var disableMainForm = function () {
    $('#param1').prop('disabled', true);
    $('#param2').prop('disabled', true);
    $('#mainFormSubmit').prop('disabled', true);
    $('#value1').prop('disabled', true);
    $('#value2').prop('disabled', true);
};

var manageValues = function () {

    $('#value1').on('change', function () {
        $('#mainFormSubmit').prop('disabled', false);
    });

    $('#value2').on('change', function () {
        $('#mainFormSubmit').prop('disabled', false);
    });

};

var checkSums = function () {
    var result2 = false;
    var value1 = $('#value1').val();
    var value2 = $('#value2').val();
    if($('#rcpid').val()){
        var ajax = $.ajax({
            url: document.location.origin + '/urlopy/rcp/checkSum',
            dataType: 'json',
            type: 'GET',
            data: {
                rcpid: $('#rcpid').val(),
                time: {dayTime:value1,nightTime:value2}
            },
            success: function (data) {
                if (data.result == 1) {
                    $('#mainFormSubmit').prop('disabled', true);
                } else {
                    $('#mainFormSubmit').prop('disabled', true);
                }
    
                if (data.remind < 0)
                    $('#remind').html('<b style="color:red;">rozpisano za dużo o: ' + data.time + '</b>');
                else if (data.remind == 0)
                    $('#remind').html('<b style="color:green;">pozostało do rozpisania:  ' + data.time + ' </b>');
                else
                    $('#remind').html('pozostało do rozpisania: ' + data.time);
            }
        });
    }
    
};

var manageParam1 = function () {

    $('#param1').on('change', function () {
        $('#param2').prop('disabled', true);
        $('#param2').val('');
        $('#mainFormSubmit').prop('disabled', true);
        $('#value1').prop('disabled', true);
        $('#value1').val('');
        $('#value2').prop('disabled', true);
        $('#value2').val('');
        if ($('#param1').val() != '') {
            var ajax = $.ajax({
                url: document.location.origin + '/urlopy/rcp/getParam2List',
                dataType: 'json',
                type: 'GET',
                data: {
                    rcpid: $('#rcpid').val(),
                    param1: $('#param1').val()
                },
                success: function (data) {
                    $('#param2').html('');
                    $('#param2').append('<option value>Wybierz...</option>')
                    $('#param2').prop('disabled', false);
                    for (var i = 0; i < data.length; i++)
                        $('#param2').append('<option value="' + data[i] + '">' + data[i] + '</option>');
                }
            });
        } else {
            $('#param2').prop('disabled', true);
            $('#param2').val('');
            $('#mainFormSubmit').prop('disabled', true);
            $('#value1').prop('disabled', true);
            $('#value1').val('');
            $('#value2').prop('disabled', true);
            $('#value2').val('');
        }
    });
};

var manageParam2 = function () {

    $('#param2').on('change', function () {
        if ($('#param2').val() != '') {
            var result2 = false;
            var value1 = $('#value1').val();
            var value2 = $('#value2').val();
            var ajax = $.ajax({
                url: document.location.origin + '/urlopy/rcp/checkSum',
                dataType: 'json',
                type: 'GET',
                data: {
                    rcpid: $('#rcpid').val(),
                    value: {dayTime:value1, nightTime:value2}
                },
                success: function (data) {
                    console.log(data);
                    if (data.remind > 0) {
                        $('#value1').prop('disabled', false);
                        $('#value1').val(data.time);
                        $('#value2').prop('disabled', false);
                        $('#value2').val('00:00');

                        $('#mainFormSubmit').prop('disabled', false);
                    }
                }
            });
        } else {
            $('#value1').prop('disabled', true);
            $('#value1').val('');
            $('#value2').prop('disabled', true);
            $('#value2').val('');
        }
    });

};