var timeLeft = 0;
var allowCounting = false;
var logoutUrl = '';
var keepAliveUrl = '';
var token = '';
var counter = function () {
    if (allowCounting) {
        if (timeLeft > 0) {
            timeLeft--;
            var minutes = (Math.floor(timeLeft / 60)).toString().padStart(2, "0");
            var seconds = (timeLeft - minutes * 60).toString().padStart(2, "0");
            var formattedTime = (minutes + ':' + seconds)
            $('#timer').html(formattedTime);
        } else {
            singOff();
        }
    }
}
var setUrls = function (logout, keepAlive) {
    logoutUrl = logout;
    keepAliveUrl = keepAlive;
}

var setTime = function (amount) {
    timeLeft = amount;
    allowCounting = true;
}

var setToken = function () {
    token = uniqueID();
    localStorage.setItem('timeoutToken', token);
}

var uniqueID = function () {
    function chr4() {
        return Math.random().toString(16).slice(-4);
    }
    return chr4() + chr4() +
        '-' + chr4() +
        '-' + chr4() +
        '-' + chr4() +
        '-' + chr4() + chr4() + chr4();
}

var singOff = function () {
    window.clearInterval(counter);
    if (localStorage.getItem('timeoutToken') === token) {
        window.location.href = logoutUrl;
    }
}

$(document).ready(function(){
    $('#timer').tooltip({
        placement: 'bottom',
        trigger: 'hover focus',
        container: 'body',
        title: 'Czas pozostały do wylogowania'
    });
});

$(document).ajaxComplete(function (event, xhr, settings) {
    if (settings.url != keepAliveUrl) {
        allowCounting = false;
        $.ajax({
            url: keepAliveUrl,
            dataType: 'json',
            success: function (data) {
                setTime(data.timeLeft);
                setToken();
            },
            error: function (data) {
                console.log('SOMETHING WENT WRONG');
            }
        });
    }
});
window.setInterval(counter, 1000);