$(document).ready(function () {
    filters();
});


function datatoggle(obj, callback) {
    obj.attr('data-html', 'true');
    callback();
}

function htmltrue(obj, callback) {
    obj.attr('data-toggle', 'tooltip');
    callback();
}

function dataplacement(obj, callback) {
    obj.attr('data-container', 'body');
    callback();
}

function datatitle(obj, data, callback) {
    obj.attr('data-original-title', '<img src="' + data + '"/>');
    callback();
}

function maketooltip(obj) {
    obj.tooltip('show');
    obj.on({
        mouseleave: function () {
            obj.tooltip('hide');
        }
    });
}
var filters = function () {
    userFilters();
    normalFilters();
}

var userFilters = function() {
    $('ul.multiselect-container li a').tooltip('destroy');
    var getH = function () {
        return window.innerHeight - ($('.pracownicy').offset().top + ($('.pracownicy').height() * 2));
    };

    $('.pracownicy').multiselect({
        numberDisplayed: 1,
        enableFiltering: true,
        maxHeight: getH(),
        enableCaseInsensitiveFiltering: true,
        optionClass: function () { return 'pracownik'; },
        buttonClass: 'btn btn-primary',
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class="fa fa-user" aria-hidden="true"></i>', 'g'), '');
            return result;
        },
        enableHTML: true,
        enableClickableOptGroups: true
    });
    var ajax;
    $('ul.multiselect-container li a').on({
        mouseenter: function () {
            var obj = $(this);
            var id = $(this).children('label').children('input').val();
            id = id.split(';');
            id = id[1];
            if (obj.attr('data-html') == undefined) {
                ajax = $.ajax({
                    url: '/urlopy/site/getAvatar',
                    type: 'GET',
                    dataType: 'json',
                    data: {
                        'id': id
                    },
                    success: (function (data) {
                        datatitle(obj, data, function () {
                            htmltrue(obj, function () {
                                dataplacement(obj, function () {
                                    datatoggle(obj, function () {
                                        maketooltip(obj);
                                    });
                                });
                            });
                        });
                    }),

                    fail: (function (data) {
                        console.log('ERROR: Avatar not loaded;');
                    })
                });
            }
        },
        mouseleave: function () {
            var obj = $(this);
            if(ajax)
                ajax.abort();
        }
    });
    //$('.multiselect-clear-filter').hide();
};

var normalFilters = function () {
    var getH = function () {
        return window.innerHeight - ($('.normal-drop').offset().top + ($('.normal-drop').height() * 2));
    };

    $('.normal-drop').multiselect({
        maxHeight: getH(),
        buttonClass: 'btn btn-primary',
        enableHTML: true,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
    });
};
