/**
 * Created by fzyminkowski on 2017-08-28.
 */
$(document).ready(function () {
    $('#tabs').off('shown.bs.tab');
    $('#tabs').on('shown.bs.tab', function (event) {

        if ($(event.target).attr('href') !== undefined) {
            Loading.show();
            $.ajax({
                dataType: 'html',
                data: {view: $(event.target).attr('href')},
                url: '/urlopy/report/holidays',
                type: 'GET',
                success: function (data) {
                    Loading.show();
                    $($(event.target).attr('href')).html(data);
                    filtry();
                    zdjecia();
                    Loading.hide();
                }
            });
        }
        if(firstShowTab === undefined)
        {
            $('a:contains("Stan urlopów")').click();
            firstShowTab = true;
        }

    });
});
var firstShowTab;

var filtry = function () {
    filtryPracownika();
    filtryRodzaju();
    filtryPracownika1();
    filtryRodzaju1();
    multiselectAll();
};

var filtryPracownika = function () {
    $('div select.holidayReportPracownicy').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        maxHeight: getH('.holidayReportPracownicy'),
        enableHTML: true,
        optionClass: function () {
            return 'pracownik';
        },
        buttonWidth: '100%',
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        enableClickableOptGroups: true,
        onChange: function (option, checked, select) {
            $.fn.yiiGridView.update('holidayReport-grid', buildJSON());
            formDataForDownload('div select.holidayReportPracownicy','.holidayReportRodzaj','#downloadReport','/urlopy/report/downloadHolidays');
        }
    });
};
var filtryPracownika1 = function () {
    $('div select.holidayBalancePracownicy').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        maxHeight: getH('.holidayBalancePracownicy'),
        enableHTML: true,
        optionClass: function () {
            return 'pracownik';
        },
        buttonWidth: '100%',
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        enableClickableOptGroups: true,
        onChange: function (option, checked, select) {
            $.fn.yiiGridView.update('holidayBalance-grid', buildJSON1());
            formDataForDownload('div select.holidayBalancePracownicy','.holidayBalanceRodzaj','#downloadBalance','/urlopy/report/downloadBalance');
        }
    });
};

var filtryRodzaju = function () {
    $('.holidayReportRodzaj').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        maxHeight: getH('.holidayReportRodzaj'),
        enableHTML: true,
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        onChange: function () {
            $.fn.yiiGridView.update('holidayReport-grid', buildJSON());
            formDataForDownload('div select.holidayReportPracownicy','.holidayReportRodzaj','#downloadReport','/urlopy/report/downloadHolidays');
        }
    });
};
var filtryRodzaju1 = function () {
    $('.holidayBalanceRodzaj').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        maxHeight: getH('.holidayBalanceRodzaj'),
        enableHTML: true,
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        onChange: function () {
            $.fn.yiiGridView.update('holidayBalance-grid', buildJSON1());
            formDataForDownload('div select.holidayBalancePracownicy','.holidayBalanceRodzaj','#downloadBalance','/urlopy/report/downloadBalance');
        }
    });
};

var formDataForDownload = function (userFilterSelector,typeFilterSelector,downloadLinkSelector,baseLink) {
    var uids = $(userFilterSelector).val();
    var rids = $(typeFilterSelector).val();
    var link = baseLink + '?';
    var linkFull = link;
    if(uids.length > 0)
        uids.map(function(currentValue, index, array){ (linkFull.substr(linkFull.length -1)==='?') ? linkFull +=('uids[]='+currentValue):linkFull +=('&uids[]='+currentValue)});
    if(rids.length > 0)
        rids.map(function(currentValue, index, array){ (linkFull.substr(linkFull.length -1)==='?') ? linkFull +=('rids[]='+currentValue):linkFull +=('&rids[]='+currentValue)});
    $(downloadLinkSelector).attr('href',linkFull);
};

var buildJSON = function () {
    var pracownicy = [];
    var rodzaj = [];
    var it = 0;
    $('div select.holidayReportPracownicy option').each(function (key, value) {
        if (value.selected === true) {
            if ($(value)) {
                pracownicy[it] = $(value).val();
                it++;
            }
        }
    });
    it = 0;
    $('div select.holidayReportRodzaj option').each(function (key, value) {
        if (value.selected === true) {
            rodzaj[it] = $(value).val();
            it++;
        }
    });

    var result = {
        data: {
            HolidayReport: {
                uid: pracownicy,
                rid: rodzaj
            }
        }
    };
    return result;
};
var buildJSON1 = function () {
    var pracownicy = [];
    var rodzaj = [];
    var it = 0;
    $('div select.holidayBalancePracownicy option').each(function (key, value) {
        if (value.selected == true) {
            if ($(value)) {
                pracownicy[it] = $(value).val();
                it++;
            }
        }
    });
    it = 0;
    $('div select.holidayBalanceRodzaj option').each(function (key, value) {
        if (value.selected == true) {
            rodzaj[it] = $(value).val();
            it++;
        }
    });

    var result = {
        data: {
            HolidayBalance: {
                userid: pracownicy,
                nazwa_elementu: rodzaj
            }
        }
    };
    return result;
};

var multiselectAll = function () {$('a.multiselect-all').on('click', function () {
    var html = $('div.btn-group.open button span.multiselect-selected-text').html();
    var openParent = $('div.btn-group.open').parent();
    var openSelect = $(openParent).children('select');
    var type = $(openSelect).attr("class").split(' ');
    var selectorType = '';
    if (type){
        selectorType ='.'+ type[type.length-1];
    }
    if (html.indexOf('Wszystkie') === 0) {
        $(selectorType).multiselect('deselectAll', false);
        $(selectorType).multiselect('updateButtonText');
    } else {
        $(selectorType).multiselect('selectAll', false);
        $(selectorType).multiselect('updateButtonText');
    }

    if(selectorType.indexOf('Report') !== 0)
    {
        $.fn.yiiGridView.update('holidayReport-grid', buildJSON());
    }else{
        $.fn.yiiGridView.update('holidayBalance-grid', buildJSON1());
    }
});
};

var zdjecia = function () {

    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true');
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-container', 'body');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<img src=\"' + data + '\"></img>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }

    var ajax = null;
    $('[data-toggle=\"tooltip\"]').tooltip();
    $('span div ul li.pracownik a').on({
        mouseenter: function () {

            var obj = $(this);
            var id = $(this).children('label').children('input').val();
            id = id.split(';');
            if (id.length > 1)
                id = id[1];
            else
                id = id[0];
            if ($.isNumeric(id)) {
                if (id != undefined) {
                    if (obj.attr('data-html') == undefined) {
                        ajax = $.ajax({
                            url: '/urlopy/site/getAvatar',
                            type: 'GET',
                            dataType: 'json',
                            data: {
                                'id': id
                            },
                            success: (function (data) {
                                datatitle(obj, data, function () {
                                    htmltrue(obj, function () {
                                        dataplacement(obj, function () {
                                            datatoggle(obj, function () {
                                                maketooltip(obj);
                                            });
                                        });
                                    });
                                });
                            }),
                            fail: (function (data) {
                                console.log('ERROR: Avatar not loaded;');
                            })
                        });
                    }
                }
            }
        },
        mouseleave: function () {
            if (ajax)
                ajax.abort();
        }
    });
};

var getH = function (selector) {
    return window.innerHeight - ($(selector).offset().top + ($(selector).height()));
};