$(document).ready(function () {


    var getH = function (selector) {
        return window.innerHeight - ($(selector).offset().top + ($(selector).height()));
    };
    $('[data-toggle="tooltip"]').tooltip();
    $('div select.dropdownlist').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        maxHeight: getH('.dropdownlist'),
        enableHTML: true,
        optionClass: function () {
            return 'pracownik';
        },
        buttonWidth: '100%',
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        enableClickableOptGroups: true
    });

    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true');
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        //	obj.attr('data-placement','left');
        obj.attr('data-container', 'body');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<img src="' + data + '"></img>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }

    var ajax;
    $('ul.multiselect-container li a').on({
        mouseenter: function () {
            var obj = $(this);
            var id = $(this).children('label').children('input').val();
            id = id.split(';');
            if (id.length > 1)
                id = id[1];
            else
                id = id[0];
            if (id !== undefined) {
                if ($.isNumeric(id)) {
                    if (obj.attr('data-html') === undefined) {
                        ajax = $.ajax({
                            url: '/urlopy/site/getAvatar',
                            type: 'GET',
                            dataType: 'json',
                            data: {
                                'id': id
                            },
                            success: (function (data) {
                                datatitle(obj, data, function () {
                                    htmltrue(obj, function () {
                                        dataplacement(obj, function () {
                                            datatoggle(obj, function () {
                                                maketooltip(obj);
                                            });
                                        });
                                    });
                                });
                            }),

                            fail: (function (data) {
                                console.log('ERROR: Avatar not loaded;');
                            })
                        });
                    }
                }
            }
        },
        mouseleave: function () {
            if (ajax){
                var obj = $(this);
                ajax.abort();
            }
        }
    });
});