$(document).ready(function () {
    updateUCP();
    exportRozliczenia();
    filtry();
});

var monthClick = function (e) {
    Loading.show();
    $('.buttonMonth').removeClass('btn-primary');
    e.addClass('btn-primary');
};

var selectProperMonth = function () {
    var ajax = $.ajax({
        type: 'GET',
        dataType: 'json',
        url: document.location.origin + '/urlopy/umowy/dateUmowy',
        success: function (data) {
            data = data.split("-");
            var month = data[1];
            $('[value="' + month + '"]').addClass('btn-primary');

        },
        error: function (err) {
            console.log(err);
        }
    });
};

var updateUCP = function () {
    $('#updateUCPAjaxButton').on('click', function () {
        var ajax = $.ajax({
            dataType: 'json',
            type: 'GET',
            async: true,
            url: document.location.origin + '/urlopy/umowy/updateUCP',
            success: function (data) {
                $.fn.yiiGridView.update('umowy-grid');
            }
        });
    });
};

var exportRozliczenia = function () {

    $('#export').on('click', function () {
        var ajax = $.ajax({
            dataType: 'json',
            type: 'GET',
            data: {id: $.fn.yiiGridView.getChecked('umowy-grid', 'someChecks')},
            url: document.location.origin + '/urlopy/umowy/export',
            success: function (data) {
                $('#eksportModal').modal('toggle');
                $.each(data, function (key, value) {
                    $('#eksportModal div.modal-body').append(value.wartosc + ' ');
                    $('#eksportModal div.modal-body').append(value.param1 + '<br />');
                });
                $.fn.yiiGridView.update('umowy-grid');
            }
        });
    });
};

var filtry = function () {
    filtryPracownika();
    filtrStan();
    filtryRodzaju();
    filtryStatusu();
    zdjecia();
    selectProperMonth();
};

var filtryPracownika = function () {
    $('div select.pracownicy').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,
        optionClass: function () {
            return 'pracownik';
        },
        buttonWidth: '100%',
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '')
            return result;
        },
        enableClickableOptGroups: true,
        onChange: function () {
            $.fn.yiiGridView.update('umowy-grid', buildJSON());
        }
    });
};

var filtryRodzaju = function () {
    $('.rodzaj').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '')
            return result;
        },
        onChange: function () {
            $.fn.yiiGridView.update('umowy-grid', buildJSON());
        }
    });
};

var filtrStan = function () {
    $('div select.stan').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '')
            return result;
        },
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        onChange: function () {
            $.fn.yiiGridView.update('umowy-grid', buildJSON());
        }
    });
};

var filtryStatusu = function () {

    $('div select.status').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '')
            return result;
        },
        disabled: true,
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        onChange: function () {
            $.fn.yiiGridView.update('umowy-grid', buildJSON());
        }
    });

    var statusItemsCollection = $('span div ul li a label input');

    for (var a = 0; a < statusItemsCollection.length; a++) {
        if (statusItemsCollection[a].value == 'nowy')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:lightblue;');
        if (statusItemsCollection[a].value == 'anulowany')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:#ffd27f;');
        if (statusItemsCollection[a].value == 'rozpatrywany')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:#ffffe0;');
        if (statusItemsCollection[a].value == 'zatwierdzony')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:lightgreen;');
        if (statusItemsCollection[a].value == 'odrzucony')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:pink;');
    }
};

var buildJSON = function () {
    var pracownicy = [];
    var stan = [];
    var rodzaj = [];
    var status = [];
    ;
    var it = 0;
    $('div select.pracownicy option').each(function (key, value) {
        if (value.selected === true) {
            if ($(value)) {
                pracownicy[it] = $(value).val();
                it++;
            }
        }
    });

    it = 0;
    $('div select.stan option').each(function (key, value) {
        if (value.selected === true) {
            stan[it] = $(value).val();
            it++;
        }
        ;
    });

    it = 0;
    $('div select.rodzaj option').each(function (key, value) {
        if (value.selected === true) {
            rodzaj[it] = $(value).val();
            it++;
        }
        ;
    });
    it = 0;
    $('div select.status option').each(function (key, value) {
        if (value.selected === true) {
            status[it] = $(value).val();
            it++;
        }
        ;
    });
    validateFilters(pracownicy, stan, rodzaj, status);
    var result = {
        data: {
            Umowy: {
                userid: pracownicy,
                nazwa_umowy: rodzaj,
                statusid: status,
                oczekuje_eksportu: stan
            }
        }
    };
    return result;
};

var validateFilters = function (pracownicy, usuniety, rodzaj, status) {
    if (
        pracownicy.length == 0
        || usuniety.length == 0
        || rodzaj.length == 0
        || status.length == 0
    ) {
        var ajax = $.ajax({
            url: '/urlopy/umowy/clearFilters',
            type: 'GET',
            success: function () {
                return true;
            },
            failt: function () {
                return false;
            }
        });
    }
};

var zdjecia = function () {

    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true')
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-container', 'body');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<img src="' + data + '"/>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }

    var ajax = null;
    $('[data-toggle=\"tooltip\"]').tooltip();
    $('td div span div ul li.pracownik a').on({
        mouseenter: function () {
            var obj = $(this);
            var id = $(this).children('label').children('input').val();
            id = id.split(';');
            if (id.length > 1)
                id = id[1];
            else
                id = id[0];
            if ($.isNumeric(id)) {
                if (id != undefined) {
                    if (obj.attr('data-html') == undefined) {
                        ajax = $.ajax({
                            url: '/urlopy/site/getAvatar',
                            type: 'GET',
                            dataType: 'json',
                            data: {
                                'id': id
                            },
                            success: (function (data) {
                                datatitle(obj, data, function () {
                                    htmltrue(obj, function () {
                                        dataplacement(obj, function () {
                                            datatoggle(obj, function () {
                                                maketooltip(obj);
                                            });
                                        });
                                    });
                                });
                            }),
                            fail: (function (data) {
                                console.log('ERROR: Avatar not loaded;');
                            })
                        });
                    }
                }
            }
        },
        mouseleave: function () {
            if (ajax)
                ajax.abort();
        }
    });
};