$(document).ready(function () {
    checkSymfonia();
    filtry();
});

var checkSymfonia = function () {
    var ajax = $.ajax({
        url: '/urlopy/wniosek/ajaxCheckSymfonia',
        type: 'GET',
        success: function () {
            $('td div span div ul li.pracownik a').tooltip('destroy');
            var currentPage = $('#wniosek-panel li.active a').html();
            $.fn.yiiGridView.update('wniosek-panel',{ data:{currentPage: currentPage}} );
        }
    });
};

var filtry = function () {
    filtryPracownika();
    filtrUsuniety();
    filtryRodzaju();
    filtryStatusu();
    zdjecia();
};

var filtryPracownika = function () {
    $('div select.pracownicy').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        maxHeight: getH('.pracownicy'),
        enableHTML: true,
        optionClass: function () { return 'pracownik'; },
        buttonWidth: '100%',
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        enableClickableOptGroups: true,
        onChange: function () {
            $.fn.yiiGridView.update('wniosek-panel', buildJSON());
        }
    });
};

var filtryRodzaju = function () {
    $('.rodzaj').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        maxHeight: getH('.rodzaj'),
        enableHTML: true,
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        onChange: function () {
            $.fn.yiiGridView.update('wniosek-panel', buildJSON());
        }
    });
};

var filtrUsuniety = function () {
    $('div select.usuniety').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        onChange: function () {
            $.fn.yiiGridView.update('wniosek-panel', buildJSON());
        }
    });
};

var communicates = {'Akceptuj wstępnie':' zaakceptowany wstępnie',
    'Akceptuj finalnie':' zaakceptowany finalnie',
    'Odrzuć':' odrzucony',
    'Anuluj':' anulowany',
    'Ukryj':' ukryty'};

var filtryStatusu = function () {

    $('div select.status').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        enableHTML: true,
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        onChange: function () {
            $.fn.yiiGridView.update('wniosek-panel', buildJSON());
        }
    });

    var statusItemsCollection = $('span div ul li a label input');

    for (var a = 0; a < statusItemsCollection.length; a++) {
        if (statusItemsCollection[a].value == 'nowy')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:lightblue;');
        if (statusItemsCollection[a].value == 'anulowany')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:#ffd27f;');
        if (statusItemsCollection[a].value == 'rozpatrywany')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:#ffffe0;');
        if (statusItemsCollection[a].value == 'zatwierdzony')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:lightgreen;');
        if (statusItemsCollection[a].value == 'odrzucony')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:pink;');
    }
};

var buildJSON = function () {
    var pracownicy = [];
    var usuniety = [];
    var rodzaj = [];
    var status = [];
    var it = 0;
    $('div select.pracownicy option').each(function (key, value) {
        if (value.selected === true) {
            if ($(value)) {
                pracownicy[it] = $(value).val();
                it++;
            }
        }
    });
    it = 0;
    $('div select.usuniety option').each(function (key, value) {
        if (value.selected === true) {
            usuniety[it] = $(value).val();
            it++;
        }
    });
    it = 0;
    $('div select.rodzaj option').each(function (key, value) {
        if (value.selected === true) {
            rodzaj[it] = $(value).val();
            it++;
        }
    });
    it = 0;
    $('div select.status option').each(function (key, value) {
        if (value.selected === true) {
            status[it] = $(value).val();
            it++;
        }
    });
    validateFilters(pracownicy, usuniety, rodzaj, status);

    var result = {
        data: {
            Wniosek: {
                userid: pracownicy,
                usuniety: usuniety,
                rodzajid: rodzaj,
                statusid: status
            }
        }
    };
    return result;
};

var validateFilters = function (pracownicy, usuniety, rodzaj, status) {
    if (
        pracownicy.length == 0
        || usuniety.length == 0
        || rodzaj.length == 0
        || status.length == 0
    ) {
        var ajax = $.ajax({
            url: '/urlopy/wniosek/clearFilters',
            type: 'GET',
            success: function () {
                return true;
            },
            fail: function () {
                return false;
            }
        });
    }
};

var zdjecia = function () {

    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true');
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-container', 'body');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<img src=\"' + data + '\"></img>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }
    var ajax = null;
    $('[data-toggle=\"tooltip\"]').tooltip();
    $('td div span div ul li.pracownik a').on({
        mouseenter: function () {
            var obj = $(this);
            var id = $(this).children('label').children('input').val();
            id = id.split(';');
            if (id.length > 1)
                id = id[1];
            else
                id = id[0];
            if (id !== undefined) {
                if ($.isNumeric(id) ) {
                    if (obj.attr('data-html') == undefined) {
                        ajax = $.ajax({
                            url: '/urlopy/site/getAvatar',
                            type: 'GET',
                            dataType: 'json',
                            async: false,
                            data: {
                                'id': id
                            },
                            success: (function (data) {
                                datatitle(obj, data, function () {
                                    htmltrue(obj, function () {
                                        dataplacement(obj, function () {
                                            datatoggle(obj, function () {
                                                maketooltip(obj);
                                            });
                                        });
                                    });
                                });
                            }),
                            fail: (function (data) {
                                console.log('ERROR: Avatar not loaded;');
                            })
                        });
                    }
                }
            }
        },
        mouseleave: function () {
            if (ajax)
                ajax.abort();
        }
    });
    $('.multiselect-clear-filter').hide();
};

var getH = function (selector) {
    return window.innerHeight - ($(selector).offset().top + ($(selector).height()));
};



function callAction(obj) {
    $('#commentModal').modal('toggle');
    $('#WniosekA').attr('action', obj.attr('href'));
    $('#commentModalTextArea').val('');
    $('#commentModalSubmitBtn').html(obj.attr('data-original-title'));
    $('#commentModalSubmitBtn').on('click', function () {
        Loading.show();
    });
    return false;
}


function passActionToChangeModal(obj) {
    $('#WniosekA').attr('action',obj.attr('href'));
    $('#myModal').modal('toggle');
    return false;
}

function callActionModal(obj) {
    $('#commentModal').modal('toggle');
    $('#commentModalTextArea').val('');
    $('#commentModalSubmitBtn').html(obj.attr('title'));
    $('#commentModalSubmitBtn').on('click', function () {
        Loading.show();
    });
    return false;
}

function ajaxRequest(object) {

    var currentPage = $('#wniosek-panel li.active a').html();
    var actionMessage = communicates[$(object).text()];
    var ajax = $.ajax({
        url: $('#WniosekA').attr('action'),
        type: 'POST',
        data: $('#WniosekA').serialize(),
        success: function () {
            Loading.hide();
            $('#commentModal').modal('toggle');
            $.fn.yiiGridView.update('wniosek-panel',{ data:{currentPage: currentPage}} );
            swal({
                title: 'Sukces!',
                text: 'Wniosek został' + actionMessage,
                type: 'success',
                timer: 2000,
            });
        },
        error: function () {
            Loading.hide();
            $('#commentModal').modal('toggle');
            $.fn.yiiGridView.update('wniosek-panel',{ data:{currentPage: currentPage}} );
            swal({
                title: 'Błąd!',
                text: 'Wystąpił błąd podczas akcji',
                type: 'error',
                timer: 2000,
            });
        }
    });
    return false;
}