/**
 * Created by Filip on 20.04.2017.
 */

$(document).ready(function () {
    multiselect();
    selectProperMonth();
    $('.fc-today-button').click(function (e) {
        $('#calendar').fullCalendar('today');
        $.ajax({
            data: { date: $('#calendar').fullCalendar('getDate').format('YYYY-MM-DD') },
            url: '/urlopy/userSet/setUserViewDate',
            dataType: 'json',
            type: 'GET',
            success: function (data) {
                $('.buttonMonth').removeClass('btn-primary');
                data = data.split("-");
                var month = data[1];
                setYears(data[0]);
                $('[value="' + month + '"]').addClass('btn-primary');
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (jqXHR.status !== 0) {
                    swal({
                        title: 'Błąd!',
                        text: 'Wystąpił błąd podczas akcji: ' + jqXHR.responseText,
                        type: 'error',
                        timer: 2000,
                    });
                }
            },
        });
    });
    $('.fc-prev-button').off('click');
    $('.fc-prev-button').click(function (e) {
        $('#calendar').fullCalendar('prev');
        $.ajax({
            data: { date: $('#calendar').fullCalendar('getDate').format('YYYY-MM-DD') },
            url: '/urlopy/userSet/setUserViewDate',
            dataType: 'json',
            type: 'GET',
            success: function (data) {
                $('.buttonMonth').removeClass('btn-primary');
                data = data.split("-");
                var month = data[1];
                setYears(data[0]);
                $('[value="' + month + '"]').addClass('btn-primary');
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (jqXHR.status !== 0) {
                    swal({
                        title: 'Błąd!',
                        text: 'Wystąpił błąd podczas akcji: ' + jqXHR.responseText,
                        type: 'error',
                        timer: 2000,
                    });
                }
            },
        });
    });
    $('.fc-next-button').off('click');
    $('.fc-next-button').click(function (e) {
        $('#calendar').fullCalendar('next');
        $.ajax({
            data: { date: $('#calendar').fullCalendar('getDate').format('YYYY-MM-DD') },
            url: '/urlopy/userSet/setUserViewDate',
            dataType: 'json',
            type: 'GET',
            success: function (data) {
                $('.buttonMonth').removeClass('btn-primary');
                data = data.split("-");
                var month = data[1];
                setYears(data[0]);
                $('[value="' + month + '"]').addClass('btn-primary');
            }
        });
    });
});

var monthClick = function (e) {
    $('.buttonMonth').removeClass('btn-primary');
    e.addClass('btn-primary');
};

var setYears = function (data) {
    data = parseInt(data);
    $('#prevYear').html(data - 1);
    $('#prevYear').val(data - 1);
    $('#nextYear').html(data + 1);
    $('#nextYear').val(data + 1);
};

var selectProperMonth = function () {
    var ajax = $.ajax({
        type: 'GET',
        dataType: 'json',
        url: '/urlopy/userSet/getUserViewDate',
        success: function (data) {
            data = data.split("-");
            var month = data[1];
            $('[value="' + month + '"]').addClass('btn-primary');
        },
        error: function (err) {
            console.log(err);
        }
    });
};

var calendarGoTo = function (data) {
    $('#calendar').fullCalendar('gotoDate', data);
};

var ajaxData = 0;
var getData = function () {
    var result;
    result = $.ajax({
        url: '/urlopy/wniosek/getPanelCalendar',
        type: 'GET',
        data: { 'PanelCalendarForm[userid]': $('.pracownicy').val(), 'PanelCalendarForm[rodzajid]': $('.rodzaje').val(), 'PanelCalendarForm[statusid]': $('.status').val() },
        success: function (data) {
            data = $.parseJSON(data);
            $('#calendar').fullCalendar('removeEvents');
            $('#calendar').fullCalendar('renderEvents', data);
        },
        error: function (jqXHR, textStatus, errorThrown) {
            if (jqXHR.status !== 0) {
                swal({
                    title: 'Błąd!',
                    text: 'Wystąpił błąd podczas akcji: ' + jqXHR.responseText,
                    type: 'error',
                    timer: 2000,
                });
            }
        },
    });
    return result;

};


var multiselect = function () {
    $('[multiple="multiple"]').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableFiltering: true,
        maxHeight: getH('[multiple="multiple"]'),
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class="fa fa-user" aria-hidden="true"></i>', 'g'), '');
            return result;
        },
        enableHTML: true,
        buttonWidth: '100%',
        enableClickableOptGroups: true,
        onChange: function () {
            if (ajaxData != 0)
                ajaxData.abort();
            ajaxData = getData();
        },
    });

    $('a.multiselect-all').on('click', function () {
        var html = $('div.btn-group.open button span.multiselect-selected-text').html();
        var openParent = $('div.btn-group.open').parent();
        var openSelect = $(openParent).children('select');
        var type = $(openSelect).attr("class").split(' ');
        var selectorType = '';
        if (type) {
            selectorType = '.' + type[type.length - 1];
        }
        if (html.indexOf('Wszystkie') === 0) {
            $(selectorType).multiselect('deselectAll', false);
            $(selectorType).multiselect('updateButtonText');
        } else {
            $(selectorType).multiselect('selectAll', false);
            $(selectorType).multiselect('updateButtonText');
        }
        if (ajaxData != 0)
            ajaxData.abort();
        ajaxData = getData();
    });

    $('[data-toggle="tooltip"]').tooltip();
    $('.multiselect-clear-filter').hide();
    var statusItemsCollection = $(' ul li a label input');

    for (var a = 0; a < statusItemsCollection.length; a++) {

        if (statusItemsCollection[a].value == 'nowy')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:lightblue;');

        if (statusItemsCollection[a].value == 'anulowany')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:#ffd27f;');

        if (statusItemsCollection[a].value == 'rozpatrywany')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:#ffffe0;');

        if (statusItemsCollection[a].value == 'zatwierdzony')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:lightgreen;');

        if (statusItemsCollection[a].value == 'odrzucony')
            statusItemsCollection[a].parentNode.parentNode.setAttribute('style', 'background-color:pink;');
    }
    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true');
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-container', 'body');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<img src="' + data + '"/>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }

    var ajax = undefined;
    $('[data-toggle="tooltip"]').tooltip();
    $('div span div ul.multiselect-container li a').on({
        mouseenter: function () {
            var obj = $(this);
            var id = $(this).children('label').children('input').val();
            id = id.split(';');
            id = id[1];
            if (id != undefined) {
                if (obj.attr('data-html') == undefined) {
                    ajax = $.ajax({
                        url: '/urlopy/site/getAvatar',
                        type: 'GET',
                        dataType: 'json',
                        data: {
                            'id': id
                        },
                        success: (function (data) {
                            datatitle(obj, data, function () {
                                htmltrue(obj, function () {
                                    dataplacement(obj, function () {
                                        datatoggle(obj, function () {
                                            maketooltip(obj);
                                        });
                                    });
                                });
                            });
                        }),
                        fail: (function (data) {
                            console.log('ERROR: Avatar not loaded;');
                        })
                    });
                }
            }
        },
        mouseleave: function () {
            var obj = $(this);
            if (ajax !== undefined)
                ajax.abort();
        }
    });
};
var getH = function (selector) {
    return window.innerHeight - ($(selector).offset().top + ($(selector).height()));
};
