function UpdateTableHeaders() {
    $(".persist-area").each(function () {

        var el = $(this),
            offset = el.offset(),
            scrollTop = $(window).scrollTop(),
            floatingHeader = $(".floatingHeader", this)

        if ((scrollTop > offset.top) && (scrollTop < offset.top + el.height())) {
            floatingHeader.css({
                "visibility": "visible"
            });
        } else {
            floatingHeader.css({
                "visibility": "hidden"
            });
        }
    });
}


$(document).ready(function () {
    Loading.show();
    getData();
    selectProperMonth();
    var ajax = 0;

    var visioDrop = $('#visioDrop');
    visioDrop.on('change', filterColumns);
    visioDrop.multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableClickableOptGroups: true,
        enableFiltering: true,
        buttonWidth: '100%',
        maxHeight: getH('#visioDrop'),
        includeSelectAllOption: false,
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,

        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        }
    });

    $('#pracownicy').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableClickableOptGroups: true,
        enableFiltering: true,
        buttonWidth: '100%',
        includeSelectAllOption: true,
        maxHeight: getH('#pracownicy'),
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info pracownikFil',
        enableHTML: true,
        optionClass: function () {
            return 'pracownik';
        },
        buttonTitle: function (options, select) {
            var labels = [];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        },
        onChange: function () {
            Loading.show();
            setSelected();
            if (ajax != 0)
                ajax.abort();
            ajax = getData(true);
        }
    });
    $('a.multiselect-all').on('click', function () {
        var html = $('button.pracownikFil span.multiselect-selected-text').html();
        if (html.indexOf('Wszystkie') === 0) {
            $('#pracownicy').multiselect('deselectAll', false);
            setSelected();
        } else {
            $('#pracownicy').multiselect('selectAll', false);
            setSelected();
        }
        Loading.show();
        if (ajax != 0)
            ajax.abort();
        ajax = getData(true);
    });
    zdjecia();
});

$(function () {

    var clonedHeaderRow;

    $(".persist-area").each(function () {
        clonedHeaderRow = $(".persist-header", this);
        clonedHeaderRow
            .before(clonedHeaderRow.clone())
            .css("width", clonedHeaderRow.width())
            .addClass("floatingHeader");

    });

    $(window)
        .scroll(UpdateTableHeaders)
        .trigger("scroll");

});

var setSelected = function () {
    chosenUserId = allUsersId.same(getUniquesIds($('#pracownicy').val()));
};

Array.prototype.same = function (a) {
    return this.filter(function (i) {
        return a.indexOf(i.toString()) >= 0;
    });
};

var setAllUsers = function (json) {
    allUsersId = json;
};

var setNextPage = function () {
    movePage('next');
};

var setPreviousPage = function () {
    movePage('prev');
};


var movePage = function (direction) {
    var firstId;
    var secondId;
    if (direction === 'next') {
        firstId = '#beginPages';
        secondId = '#endPages';
    } else {
        firstId = '#endPages';
        secondId = '#beginPages';
    }
    $(firstId).removeClass('disabled');
    var currentPageDOM = $('.disabled > a');
    var newPageNum = parseInt(currentPageDOM.text()) + ((direction === 'next') ? 1 : -1);
    var newButton = ((direction === 'next') ? currentPageDOM.parent().next() : currentPageDOM.parent().prev());
    if (newButton.attr('id') !== $(secondId).attr('id')) {
        Loading.show();
        setPageNum(newPageNum, newButton.children());
    } else {
        return false;
    }

};

var setPageNum = function (number, eventSender) {
    pageNumber = parseInt(number);
    pages = $('.pages');
    pages.removeClass('disabled');
    $(eventSender).parent().addClass('disabled');
    getData();
};

var resizePage = function (value) {
    Loading.show();
    pageSize = parseInt(value);
    getData(true);
};

var renderPager = function () {
    usersAmount = totalCount;
    count = 0;
    count = (usersAmount / pageSize) + ((usersAmount % pageSize != 0) ? 1 : 0);
    result = '';
    for (var i = 1; i <= count; i++) {
        if (i == 1) {
            result += '<li class = "disabled pages"><a onclick="setPageNum($(this).text(),$(this))" href="#">' + i + '</a></li>';
        } else {
            result += '<li class = "pages"><a onclick="setPageNum($(this).text(),$(this))" href="#">' + i + '</a></li>';
        }
    }
    $('.pages').remove();
    $(result).insertAfter($('#beginPages'));
};

var setPagination = function () {
    if (pageNumber != 1)
        startIndex = (pageSize * (pageNumber - 1));
    else
        startIndex = 0;
    endIndex = startIndex + pageSize - ((startIndex == 0) ? 1 : 0);
    if (chosenUserId.length != 0) {
        totalCount = chosenUserId.length;
        orderArray = getOrderFromArray(chosenUserId);
        userIds = getProperIds(chosenUserId, startIndex, endIndex);
    } else {
        totalCount = allUsersId.length;
        orderArray = getOrderFromArray(allUsersId);
        userIds = getProperIds(allUsersId, startIndex, endIndex);
    }
}

var getOrderFromArray = function (array) {
    for (let index = 0; index < array.length; index++) {
        const element = array[index];
        orderArray[element] = (index + 1);

    }
    return orderArray;
};

var getUniquesIds = function (array) {
    helperArray = [];
    array.forEach(element => {
        digts = element.split(';');
        id = digts[1];
        if (helperArray.indexOf(digts[1]) === -1)
            helperArray.push(digts[1]);
    });
    return helperArray;
};

var getProperIds = function (array, startIndex, endIndex) {
    var numToTake;
    if (array[endIndex] !== undefined) {
        numToTake = endIndex + 1;
        if (startIndex != 0) numToTake--;
        result = array.slice(startIndex, numToTake);

    } else {
        numToTake = array.length;
        result = array.slice(startIndex);
    }
    $('#textPagination').html('Wyświetlono rezultaty ' + (startIndex + 1) + '-' + numToTake + ' z ' + totalCount + '&nbsp;');
    return result;
}

var allUsersId = [];
var chosenUserId = [];
var orderArray = [];
var userIds = [];
var pageSize = 20;
var pageNumber = 1;
var totalCount = 0;


var filterColumns = function () {
    var vals = [];
    vals = $('#visioDrop').val();
    if ($.inArray("0", vals) === -1) {
        $('.days').show();
    } else {
        $('.days').hide();
    }
    if ($.inArray("1", vals) === -1) {
        $('.rcp').show();
    } else {
        $('.rcp').hide();
    }
    if ($.inArray("2", vals) === -1) {
        $('.summary').show();
    } else {
        $('.summary').hide();
    }
};


var getH = function (selector) {
    return window.innerHeight - ($(selector).offset().top + ($(selector).height()));
};

var userPatterns = [];
var usersCount = 0;
var errorCounter = 0;
var ajaxProcessCount = 0;

var WORKPATTERNS;
var workPatternSuccess = function (data) {
    WORKPATTERNS = data;
    ajaxProcessCount--;
    data = $.parseJSON(data);
    var row;
    var color;
    var myObj;
    var content = '';
    for (var key1 in data) {
        for (var key in data[key1]) {
            if (key !== 'sum') {
                row = data[key1][key];

                color = row.type;
                myObj = $('td.days[popover-id="' + key1 + '"][popover-name="' + key + '"] div.workPattern');

                if (row.time == 0) {
                    content = '';
                } else {
                    content = row.time;
                }

                if (row.type == 0) {
                    color = 'rgba(255,0,0, 0.2)';
                }

                myObj.html(content);
                myObj.css('background-color', color);
                myObj.css('background-image', 'none');
                if (myObj.parent().children('div.workEvents').html() == '') {
                    myObj.parent().html('<div style="background-color: ' + color + '; background-image:none; font-size: 10px; height: 31px;">' + content + '</div>');
                }
            } else {
                row = data[key1][key];

                rcp = $('#' + key1 + '_a').html();
                seconds = getSecondsFromString(rcp);
                total = row.u + row.s + seconds
                $('#' + key1 + '_u').html(TimeToHHMM(row.u));
                $('#' + key1 + '_s').html(TimeToHHMM(row.s));
                $('#' + key1 + '_a').html(TimeToHHMM(total));
                $('#' + key1 + '_dp').html(TimeToHHMM(row.dp));
                $('#' + key1 + '_norm').html(TimeToHHMM(row.norm));
            }

        }
    }
    Loading.hide();
};

var getUserPattern = function (userid) {
    Loading.show();
    ajaxProcessCount++;
    $.ajax({
        type: 'POST',
        data: {
            YII_CSRF_TOKEN: atob(getcsrf()),
            date: $('#hiddenDate').val(),
            userid: userid
        },
        url: '/urlopy/workPattern/getMonth',
        success: function (data) {
            workPatternSuccess(data);
            $('#accessField').val('true');
            Loading.hide();
        },
        fail: function (err) {
            Loading.hide();
        },
        error: function (err) {

        }
    });
};

var clearCacheAndReloadPatterns = function () {
    Loading.show();
    var ajax = $.ajax({
        type: 'GET',
        url: '/urlopy/workPattern/clearWorkPatternCache',
        success: function (data) {
            buildWorkPatterns();
            Loading.hide;
        },
        error: function (err) {
            //   console.log(err);
        }
    });
};

var getData = function (doRefresh = false) {
    if (doRefresh) {
        pageNumber = 1;
    }
    setPagination();
    if (doRefresh) {
        renderPager();
    }
    var ajax = $.ajax({
        type: 'POST',
        dataType: 'json',
        data: {
            YII_CSRF_TOKEN: atob(getcsrf()),
            date: $('#hiddenDate').val(),
            userid: userIds
        },
        url: '/urlopy/rcp/getDaysList',
        success: function (data) {

            $('[data-toggle="popover"]').popover('destroy');
            if (data !== null) {
                drawTable(data);
            }
            if ($('#accessField').val() == 'true') {
                buildWorkPatterns();
            }
            usersCount = data.length;
            filterColumns();

        },
        error: function (err) {

        }
    });
    return ajax;
};
var selectProperMonth = function () {
    var ajax = $.ajax({
        type: 'GET',
        dataType: 'json',
        url: '/urlopy/userSet/getUserViewDate',
        success: function (data) {
            data = data.split("-");
            var month = data[1];
            $('[value="' + month + '"]').addClass('btn-primary');

        },
        error: function (err) {
            //       console.log(err);
        }
    });
};

var yearClick = function (chosenYear) {
    var ajax = $.ajax({
        data: {'year': chosenYear},
        type: 'GET',
        dataType: 'json',
        url: '/urlopy/userSet/setUserViewYear',
        success: function (data) {
            $('#hiddenDate').val(data);
            data = data.split("-");
            var year = data[0];
            $("#next").html((parseInt(year) + 1));
            $("#next").attr('value', (parseInt(year) + 1));
            $("#prev").html((parseInt(year) - 1));
            $("#prev").attr('value', (parseInt(year) - 1));
            getData();
        },
        error: function (err) {
            console.log(err);
        }
    });
    return false;
}
var drawTable = function (data) {
    var table = buildTable(data);
    $('#tableContainer').html(table);
    listaTooltip();
    listaPopover();
};

var buildWorkPatterns = function () {

    var userid = [];
    $('.myTableRow').each(function (key, value) {
        var rowArray = $('.myTableRow');//[i].attr('userid');
        userid[key] = $(rowArray[key]).attr('userid');
    });
    getUserPattern(userid);
};


var buildTable = function (data) {
    var table = '<table style="width:100%; max-width:100%" class="persist-area">';
    table += buildRows(data);
    table += '</table>';
    return table;

};

var buildRows = function (data) {
    var row = '';
    var days = 0;
    for (var key in data[0].days) {
        days++;
    }

    row += '<thead style= position: "fixed">';
    row += '<tr class="persist-header">';
    row += '<th>Lp.</th>';
    row += '<th>Pracownik</th>';
    for (var key in data[0].days) {
        row += '<th class="days" >' + key + '</th>';
    }
    row += '<th class="rcp" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Przepracowanych godzin (RCP)" style="min-width: 31px;max-width: 31px; border-left: 3px solid;">RCP</th>';
    row += '<th class="summary" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Urlopy (U)" style="min-width: 31px;max-width: 31px;">U</th>';
    row += '<th class="summary" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Choroby (Ch)" style="min-width: 31px;max-width: 31px;">Ch</th>';
    row += '<th class="summary" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Razem zarejestrowanch godzin (RCP+U+Ch)" style="min-width: 31px;max-width: 31px; ">RG</th>';
    row += '<th class="summary" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Do przepracowania godzin (N-U-Ch)" style="min-width: 31px;max-width: 31px; border-left: 3px solid;">DP</th>';
    row += '<th class="summary" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Norma pracy (N)" style="min-width: 31px;max-width: 31px;">N</th>';
    row += '</tr>';
    row += '</thead>';

    row += '<tbody>';
    for (var i = 0; i < data.length; i++) {
        row += '<tr userid="' + data[i]['userid'] + '" class="myTableRow">';
        row += buildCells(data[i], i + 1);
        row += '</tr>';
    }
    row += '</tbody>';

    return row;
};
var monthClick = function (e) {
    $('.buttonMonth').removeClass('btn-primary');
    Loading.show();
    e.addClass('btn-primary');
};
var buildCells = function (model, i) {
    var cells = '';
    cells += buildCell(model.user, orderArray[model.userid]);

    //   getUserPattern(model.userid);
    for (var key in model.days) {
        cells += buildDayCell(model.days[key], model.userid, key);
    }
    cells += buildSummaryCell(model, model.userid);
    return cells;
};

var tdStyle = 'padding: 0px; min-width:25px; max-width:25px; border: 1px solid #303030; text-align: center; min-height: 30px; max-height: 30px; ';

var buildDayCell = function (callback, userid, day) {
    var cells = '';
    cells += '<td class="days" popover-id="' + userid + '" popover-name="' + day + '" style="background-color:' + callback.color + '; ' + tdStyle;
    if (callback.popover == '') {
        cells += 'font-size: 1em;';
        if (callback.text != '') {
            cells += ' cursor:pointer;" data-toggle="popover"><div style="height:15px; font-size:10px; border-bottom: 1px solid #303030;" class="workPattern"></div><div style="height:15px; " class="workEvents">' + callback.text + '</div>';
        } else {
            cells += ' cursor:pointer;" data-toggle="popover" id="emptyCell" ><div style="height:15px; font-size:10px; border-bottom: 1px solid #303030;" class="workPattern"></div><div class="workEvents" style="height:15px; "></div>';
        }
    }
    if (callback.popover == 'false') {
        cells += ' cursor:pointer; ' + (('<i class="fa fa-tags" aria-hidden="true"></i>' == callback.text) ? 'font-size:1.1em;' : 'font-size:10px;') + '" data-toggle="popover"><div style="height:15px; font-size:10px; border-bottom: 1px solid #303030;" class="workPattern"></div><div class="workEvents" style="height:15px; ">' + callback.text + '</div>';
    }
    if (callback.popover == 'true') {
        cells += ' cursor:pointer; font-size:1.1em;" data-toggle="popover"><div style="height:15px; font-size:10px; border-bottom: 1px solid #303030;" class="workPattern"></div><div class="workEvents" style="height:15px; "><i class="fa fa-tags" aria-hidden="true"></i></div>';
    }
    cells += '</td>';
    return cells;
};
var buildCell = function (callback, i) {
    var cells = '';
    cells += '<td style="border: 1px solid #303030; "><b>';
    cells += i + '. ';
    cells += '</b></td>';
    cells += '<td style="border: 1px solid #303030; "><b>';
    cells += callback;
    cells += '</b></td>';
    return cells;
};
var buildSummaryCell = function (callback, userid) {


    var cells = '';
    cells += '<td class="rcp" id="' + userid + '_rcp" data-viewport="#tableContainer" data-container="body" rel="tooltip" data-html="true" data-original-title="Zaplanowanych: ' + callback.plannedTime + 'h<br/>Rozpisanych: ' + callback.made + 'h<br/>Do rozpisania: ' + callback.toMake + 'h" style="border: 1px solid #303030; text-align: right; background-color: #e6f2ff;  border-left: 3px solid; font-size: 10px;">';
    cells += callback.summary + ' ';
    cells += '</td>';
    cells += '<td class="summary" id="' + userid + '_u" style="border: 1px solid #303030; text-align: right; background-color: #e6f2ff; font-size: 10px;">';
    cells += callback.sum.holidays;
    cells += '</td>';
    cells += '<td class="summary" id="' + userid + '_s" style="border: 1px solid #303030; text-align: right; background-color: #e6f2ff; font-size: 10px;">';
    cells += callback.sum.sickDays;
    cells += '</td>';
    cells += '<td class="summary" id="' + userid + '_a" style="border: 1px solid #303030;  text-align: right; background-color: lightblue; font-size: 10px;">';
    cells += callback.sum.razem;
    cells += '</td>';
    cells += '<td class="summary" id="' + userid + '_dp" style="border: 1px solid #303030; border-left: 3px solid; text-align: right; background-color: lightblue;  font-size: 10px;">';
    cells += callback.sum.toWork + ' ';
    cells += '</td>';
    cells += '<td class="summary" id="' + userid + '_norm" style="border: 1px solid #303030; text-align: right; background-color: #e6f2ff; font-size: 10px;">';
    cells += callback.sum.fullWorkTime;
    cells += '</td>';
    return cells;
};
var listaTooltip = function () {
    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true')
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-placement', function () {
            var position = $(obj).position();
            if (position.top < 110) {
                return "bottom";
            }

            return "top";
        });
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-template', '<div class="tooltip" role="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner col-xs-12" style="max-height:200px; min-width:300px;"></div></div>');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<div class="col-xs-6"><img src=\"' + data.img + '\"/></div><div class="col-xs-1"></div><div class="col-xs-5"><p>Ostatnia aktywność: ' + data.lastActivity + '</p></div>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }

    var ajax = null;
    $('[data-toggle=\"tooltip\"]').tooltip();
    $('[rel="tooltip"]').tooltip();
    $('.fa-user.fa-lg.lista-tooltip').on({
        mouseenter: function () {
            var obj = $(this);
            var id = $(this).attr('id');
            if ($.isNumeric(id)) {
                if (id != undefined) {
                    if (obj.attr('data-html') == undefined) {
                        ajax = $.ajax({
                            url: '/urlopy/rcp/getTooltip',
                            type: 'GET',
                            dataType: 'json',
                            data: {
                                'id': id
                            },
                            success: (function (data) {
                                datatitle(obj, data, function () {
                                    htmltrue(obj, function () {
                                        dataplacement(obj, function () {
                                            datatoggle(obj, function () {
                                                maketooltip(obj);
                                            });
                                        });
                                    });
                                });
                            }),
                            fail: (function (data) {
                                //    console.log('ERROR: Avatar not loaded;');
                            })
                        });
                    }
                }
            }
        },
        mouseleave: function () {
            if (ajax)
                ajax.abort();
        }
    });
}

var listaPopover = function () {
    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true');
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'popover');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-template', '<div class="popover"><div class="arrow"></div><div class="popover-content"></div></div>');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-content', data);
        callback();
    }

    function maketooltip(obj) {
        obj.popover('show');
    }

    var ajax = null;
    $('[data-toggle="popover"]').popover({
        viewport: '#tableContainer',
        container: 'body',
        html: true,
        placement: function (context, source) {
            var position = $(source).position();
            if (position.left > 515) {
                return "left";
            }

            if (position.left < 515) {
                return "right";
            }

            if (position.top < 110) {
                return "bottom";
            }

            return "top";
        }
    });
    $('[data-toggle="popover"]').on('click', function () {
        var obj = $(this);
        var userid = obj.attr('popover-id');
        var day = obj.attr('popover-name');
        var date = $('#hiddenDate').val();
        if (day != undefined && userid != undefined) {
            if (obj.attr('data-html') == undefined) {
                ajax = $.ajax({
                    url: '/urlopy/rcp/getPopover',
                    type: 'GET',
                    dataType: 'json',
                    data: {
                        'userid': userid,
                        'day': day
                    },
                    success: (function (data) {
                        var addTable = '<table><tr><td><h4 style="font-size:15px !important;">Dodaj</h4></td>' +
                            '<td>' +
                            '<a onclick="Loading.show()"' +
                            'rel="tooltip" data-original-title="Zapis RCP"' +
                            'href="/urlopy/rcp/special?userid=' + userid + '&date=' + date + '&day=' + day + '">' +
                            '<i style="color:black;margin-left:5px; ;" class="fa ' +
                            'fa-clock-o" ' +
                            'aria-hidden="true"></i></a>' +
                            '<a onclick="Loading.show()" ' +
                            'rel="tooltip" data-original-title="Zdarzenie"' +
                            'href="/urlopy/wniosek/special?userid=' + userid + '&date=' + date + '&day=' + day + '"><i style="color:black;' +
                            'margin-left:4px; ' +
                            'margin-right:4px;" ' +
                            'class="fa fa-calendar-plus-o" aria-hidden="true"></i></a>' +
                            '</td></tr></table>';
                        if (data.length <= 29) {
                            data = addTable;
                        } else {
                            data = addTable + data;
                        }
                        datatitle(obj, data, function () {
                            htmltrue(obj, function () {
                                dataplacement(obj, function () {
                                    datatoggle(obj, function () {
                                        maketooltip(obj);
                                    });
                                });
                            });
                        });
                    }),
                    fail: (function (data) {
                        //     console.log('ERROR: Avatar not loaded;');
                    })
                });
            }

        } else {

        }
        return true;
    });
    $('body').on('click', function (e) {
        $('[data-toggle="popover"]').each(function () {
            //the 'is' for buttons that trigger popups
            //the 'has' for icons within a button that triggers a popup
            if (!$(this).is(e.target) && $(this).has(e.target).length === 0 && $('.popover').has(e.target).length === 0) {
                $(this).popover('hide');
            }
        });
    });
};

function callAction(obj) {
    $('#commentModal').modal('toggle');
    $('#WniosekA').attr('action', obj.attr('href'));
    $('#commentModalSubmitBtn').html(obj.attr('data-original-title'));
    $('#commentModalSubmitBtn').on('click', function () {
        Loading.show();
        $('#commentModalSubmitBtn').hide();
    });
    return false;
}

function passActionToChangeModal(obj) {
    $('#WniosekA').attr('action', obj.attr('href'));
    $('#myModal').modal('toggle');
    return false;
}

function callActionModal(obj) {
    $('#commentModal').modal('toggle');
    $('#commentModalSubmitBtn').html(obj.attr('title'));
    $('#commentModalSubmitBtn').on('click', function () {
        Loading.show();
        $('#commentModalSubmitBtn').hide();
    });
    return false;
}

var zdjecia = function () {

    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true');
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'tooltip');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-container', 'body');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-original-title', '<img src="' + data + '"></img>');
        callback();
    }

    function maketooltip(obj) {
        obj.tooltip('show');
        obj.on({
            mouseleave: (function () {
                obj.tooltip('hide');
            })
        });
    }

    var ajax = null;
    $('[data-toggle="tooltip"]').tooltip();
    $('div ul li.pracownik a').on({
        mouseenter: function () {

            var obj = $(this);
            var id = $(this).children('label').children('input').val();
            id = id.split(';');
            if (id.length > 1)
                id = id[1];
            else
                id = id[0];
            if (id !== undefined) {
                if ($.isNumeric(id)) {
                    if (obj.attr('data-html') == undefined) {
                        ajax = $.ajax({
                            url: '/urlopy/site/getAvatar',
                            type: 'GET',
                            dataType: 'json',
                            data: {
                                'id': id
                            },
                            success: (function (data) {
                                datatitle(obj, data, function () {
                                    htmltrue(obj, function () {
                                        dataplacement(obj, function () {
                                            datatoggle(obj, function () {
                                                maketooltip(obj);
                                            });
                                        });
                                    });
                                });
                            }),
                            fail: (function (data) {

                            })
                        });
                    }
                }
            }
        },
        mouseleave: function () {
            if (ajax)
                ajax.abort();
        }
    });
};

var TimeToHHMM = function (time) {
    var hours = (Math.floor(time / 3600)).toString().padStart(2, "0");
    var minutes = (Math.floor((time - hours * 3600) / 60)).toString().padStart(2, "0");
    var formattedTime = (hours + ':' + minutes);
    return formattedTime;
};

var getSecondsFromString = function (str) {
    var regex = /\d{1,}:/;
    var hours;
    hours = regex.exec(str);
    if (!hours)
        return 0;
    hours = hours[0].replace(':', '');
    seconds = 0;
    seconds += hours * 3600;
    var regex = /:\d{1,}/;
    var minutes;
    minutes = regex.exec(str);
    minutes = minutes[0].replace(':', '');
    seconds += minutes * 60;
    return seconds;
}