/**
 * Created by fzyminkowski on 2017-04-27.
 */
$(document).ready(function () {
    columnFilter();
    typePick();
    selectProperMonth();
});

var YEAR = 0;
var DATA;

var typePick = function () {
    $('#alignleft').on('click', function () {
        drawTable(DATA);
        drawUserPattern(WORKPATTERNS);
        $(this).addClass('btn-primary');
        $('#alignmiddle').removeClass('btn-primary');

    });
    $('#alignmiddle').on('click', function () {
        drawTable2();
        drawUserPattern(WORKPATTERNS);
        $(this).addClass('btn-primary');
        $('#alignleft').removeClass('btn-primary');
    });
};
var drawUserPattern = function (data) {
    WORKPATTERNS = data;

    data = $.parseJSON(data);
    for (var key1 in data) {
        if(key1 !== 'sum'){
            for (var key in data[key1]) {
                if(key !== 'month'){
                    var row = data[key1][key];
    
                    var color = row.type;
                    var myObj = $('td.days[month="' + key1 + '"][day="' + key + '"] div.workPattern');
    
                    var content = '';
                    if (row.time == 0) {
                        content = '';
                    } else {
                        content = row.time;
                    }
                    if (row.type == 0) {
                        color = 'rgba(255,0,0, 0.2)';
                    }
    
                    myObj.html(content);
                    myObj.css('background-color', color);
                    myObj.css('background-image', 'none');
                    if (myObj.parent().children('div.workEvents').html() == '') {
                        myObj.parent().html('<div style="background-color: ' + color + '; background-image:none; font-size: 10px; height: 31px;">' + content + '</div>');
                    }
                }else{
                    row = data[key1][key];
                
                    rcp = $('#'+key1+'_rcp').html();
                    seconds = getSecondsFromString(rcp);
                    total = row.u + row.s + seconds
                    $('#'+key1+'_u').html(TimeToHHMM(row.u));
                    $('#'+key1+'_ch').html(TimeToHHMM(row.s));
                    $('#'+key1+'_rg').html(TimeToHHMM(total));
                    $('#'+key1+'_dp').html(TimeToHHMM(row.dp));
                    $('#'+key1+'_n').html(TimeToHHMM(row.norm));
                }
            }
        }else{
            row = data[key1];
            rcp = $('#'+key1+'_rcp').html();
            seconds = getSecondsFromString(rcp);
            total = row.u + row.s + seconds
            $('#'+key1+'_u').html(TimeToHHMM(row.u));
            $('#'+key1+'_ch').html(TimeToHHMM(row.s));
            $('#'+key1+'_rg').html(TimeToHHMM(total));
            $('#'+key1+'_dp').html(TimeToHHMM(row.dp));
            $('#'+key1+'_n').html(TimeToHHMM(row.norm));
        }
    }
    Loading.hide();
};

var getUserPattern = function (userid) {
    if ($('#accessField').val()) {
        $.ajax({
            type: 'GET',
            data: {
                userid: userid
            },
            url: '/urlopy/workPattern/getYearForUser',
            success: drawUserPattern,
            fail: function (err) {

            },
            error: function (err) {

            }
        });
    } else {
        Loading.hide();
    }
};

var filterColumns = function () {
    var vals = [
    ];
    vals = $('#visioDrop').val();
    if ($.inArray("0", vals) === -1) {
        $('.days').show();
    } else {
        $('.days').hide();
    }
    if ($.inArray("1", vals) === -1) {
        $('.rcp').show();
    } else {
        $('.rcp').hide();
    }
    if ($.inArray("2", vals) === -1) {
        $('.summary').show();
    } else {
        $('.summary').hide();
    }
};

var columnFilter = function () {
    $('#visioDrop').on('change', filterColumns);
    $('#visioDrop').multiselect({
        allSelectedText: 'Wszystkie',
        numberDisplayed: 0,
        enableClickableOptGroups: true,
        enableFiltering: true,
        selectAllValue: undefined,
        buttonWidth: '100%',
        maxHeight: getH('#visioDrop'),
        enableCaseInsensitiveFiltering: true,
        buttonClass: 'btn btn-info',
        enableHTML: true,

        buttonTitle: function (options, select) {
            var labels = [
            ];
            options.each(function () {
                labels.push($(this).text());
            });
            var find = labels.join(', ');
            var result = find.replace(new RegExp('&nbsp', 'g'), '');
            result = result.replace(new RegExp('<i class=\"fa fa-user\" aria-hidden=\"true\"></i>', 'g'), '');
            return result;
        }
    });
};

var getH = function (selector) {
    return window.innerHeight - ($(selector).offset().top + ($(selector).height()));
};

var prev = function () {
    var curr = parseInt($('.curr').attr('value'));
    YEAR = curr - 1;
    $('.prev').attr('value',(curr - 2));
    $('.prev').html((curr - 2));
    $('.curr').attr('value',curr - 1);
    $('.curr').html(curr - 1);
    $('.next').attr('value',(curr));
    $('.next').html((curr));
    console.log(YEAR);
};

var next = function () {
    var curr = parseInt($('.curr').attr('value'));
    YEAR = curr + 1;
    $('.prev').attr('value',(curr));
    $('.prev').html(curr);
    $('.curr').attr('value',(curr+1));;
    $('.curr').html((curr + 1));
    $('.next').attr('value',(curr+2));
    $('.next').html((curr + 2));
    console.log(YEAR);
};
var WORKPATTERNS;
var selectProperMonth = function () {
    var ajax = $.ajax({
        type: 'GET',
        dataType: 'json',
        url: '/urlopy/userSet/getUserViewDate',
        success: function (data) {

            data = data.split("-");
            var year = data[0];
            YEAR = year;
            $('[value="' + year + '"]').addClass('btn-primary');
            getData();
        },
        error: function (err) {
            console.log(err);
        }
    });
};

var getData = function () {
    var ajax = $.ajax({
        type: 'GET',
        dataType: 'json',
        url: '/urlopy/wniosek/getUserTable',
        success: function (data) {
            DATA = data;
            //    drawTable2();
            drawTable(data);
            getUserPattern($('#userid').val());
            $('[rel="tooltip"]').tooltip();
            Loading.hide();
        },
        error: function (err) {
            console.log(err);
        }
    });
};

var drawTable = function (data) {
    var container = $('#tableContainer');
    var table = $('<table></table>');
    var row = $('<tr></tr>');
    var thead = $('<thead></thead>');
    var tbody = $('<tbody></tbody>');
    var th = '<th></th>'
    container.html(table.addClass('table-userTable'));
    table.append(thead);
    thead.append(row);
    row.append($(th).html('Miesiąc'));
    for (var i = 0; i < 31; i++) {
        row.append($(th).html(i + 1).addClass('days'));
    }

    row.append($(th).html('RCP')
            .addClass('rcp')
            .addClass('ex')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Przepracowanych godzin (RCP)')
            );
    row.append($(th).html('U')
            .addClass('summary')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Urlopy (U)')
            );
    row.append($(th).html('Ch')
            .addClass('summary')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Choroby (Ch)')
            );
    row.append($(th).html('RG')
            .addClass('summary')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Razem zarejestrowanch godzin (RCP+U+Ch)')
            );
    row.append($(th).html('DP')
            .addClass('summary')
            .addClass('ex')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Do przepracowania godzin (N-U-Ch)')
            );
    row.append($(th).html('N')
            .addClass('summary')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Norma pracy (N)')
            );

    table.append(tbody);
    row = '<tr></tr>';
    var cell = '<td></td>';
    var j = 1;
    var today = new Date();
    var dd = today.getDate();
    var mm = today.getMonth() + 1;
    var rr = today.getFullYear();

    for (var month in data) {
        var row_ = $(row);
        if (month === 'sum') 
            monthName = 'Razem';
        else
            monthName = month;
        row_.append($(cell).html(monthName).addClass('month'));
        for (var i = 1; i <= 31; i++) {
            var cell_ = $(cell);
            if (i in data[month]) {
                cell_.css('background-color', data[month][i]['color']);
                cell_.attr('day', i);
                cell_.attr('month', j);

                if (i === dd && j === mm && YEAR == rr) {
                    cell_.addClass('today');
                }

                cell_.addClass('days');
                cell_.css('cursor', 'pointer');
                if (DATA[month][i]['eventsCount'] === 1) {
                    var text = DATA[month][i]['events']['text'];
                    cell_.html('<div style="height:15px; font-size:10px; border-bottom: 1px solid #303030;" class="workPattern"></div><div style="height:15px; " class="workEvents">' + text + '</div>');
                }
                if (DATA[month][i]['eventsCount'] > 1) {
                    cell_.css('font-size', '1.1em');
                    cell_.css('background-color', 'white');
                    var text = '<i class="fa fa-tags" aria-hidden="true"></i>';
                    cell_.html('<div style="height:15px; font-size:10px; border-bottom: 1px solid #303030;" class="workPattern"></div><div style="height:15px; " class="workEvents">' + text + '</div>');

                }
                if (DATA[month][i]['eventsCount'] === 0) {
                    cell_.addClass('days').html('<div style="height:31px; font-size:10px; line-" class="workPattern"></div');

                }
            } else {
                cell_.addClass('empty').addClass('days').html('<div style="height:31px; font-size:10px;" class="workPattern"></div');


                if (month === 'sum')
                    cell_.addClass('no-border');
            }
            row_.append(cell_);
        }
        if (month === 'sum'){
            row_.addClass('sum');
            j = 'sum';
        }
        row_.append($(cell).html(data[month]['rcp']).addClass('rcp').addClass('ex').attr('id',j+'_rcp'));
        row_.append($(cell).html(data[month]['u']).addClass('summary').attr('id',j+'_u'));
        row_.append($(cell).html(data[month]['ch']).addClass('summary').attr('id',j+'_ch'));
        row_.append($(cell).html(data[month]['rg']).addClass('summary').css('background-color', 'lightblue').attr('id',j+'_rg'));
        row_.append($(cell).html(data[month]['dp']).addClass('summary').addClass('ex').css('background-color', 'lightblue').attr('id',j+'_dp'));
        row_.append($(cell).html(data[month]['n']).addClass('summary').attr('id',j+'_n'));
        j++;
        tbody.append(row_);
    }
    popover();
    filterColumns();
};

var popover = function () {
    var ajax = null;

    function datatoggle(obj, callback) {
        obj.attr('data-html', 'true');
        callback();
    }

    function htmltrue(obj, callback) {
        obj.attr('data-toggle', 'popover');
        callback();
    }

    function dataplacement(obj, callback) {
        obj.attr('data-template', '<div class="popover"><div class="arrow"></div><div class="popover-content"></div></div>');
        callback();
    }

    function datatitle(obj, data, callback) {
        obj.attr('data-content', data);
        callback();
    }

    function maketooltip(obj) {
        obj.popover('show');
    }

    $('.days').popover({
        viewport: '#tableContainer',
        container: 'body',
        html: true,
        placement: function (context, source) {
            var position = $(source).position();

            if (position.left > 515) {
                return "left";
            }

            if (position.left < 515) {
                return "right";
            }

            if (position.top < 110) {
                return "bottom";
            }

            return "top";
        }
    });
    $('.days').on('click', function () {
        var obj = $(this);
        var day = obj.attr('day');
        var month = obj.attr('month');
        if (!obj.hasClass('empty')) {
            if (day !== undefined && month !== undefined) {
                if (obj.attr('data-html') === undefined) {
                    ajax = $.ajax({
                        url: '/urlopy/wniosek/getPopover',
                        type: 'GET',
                        dataType: 'json',
                        data: {
                            'day': day,
                            'month': month
                        },
                        success: (function (data) {
                            var date = YEAR + '-' + month + '-' + day;
                            var addTable = '<table><tr><td><h4 style="font-size:15px !important;">Dodaj</h4></td>' +
                                    '<td>' +
                                    '<a onclick="Loading.show()"' +
                                    'rel="tooltip" data-original-title="Zapis RCP"' +
                                    'href="/urlopy/rcp/create?date=' + date + '&day=' + day + '">' +
                                    '<i style="color:black;margin-left:5px; ;" class="fa ' +
                                    'fa-clock-o" ' +
                                    'aria-hidden="true"></i></a>' +
                                    '<a onclick="Loading.show()" ' +
                                    'rel="tooltip" data-original-title="Zdarzenie"' +
                                    'href="/urlopy/wniosek/create?date=' + date + '&day=' + day + '"><i style="color:black;' +
                                    'margin-left:4px; ' +
                                    'margin-right:4px;" ' +
                                    'class="fa fa-calendar-plus-o" aria-hidden="true"></i></a>' +
                                    '</td></tr></table>';
                            if (data.length <= 29) {
                                data = addTable;
                            } else {
                                data = addTable + data;
                            }
                            datatitle(obj, data, function () {
                                htmltrue(obj, function () {
                                    dataplacement(obj, function () {
                                        datatoggle(obj, function () {
                                            maketooltip(obj);

                                        });
                                    });
                                });
                            });

                        }),
                        fail: (function (data) {
                            console.log('ERROR: Avatar not loaded;');
                        })
                    });
                }
            }
        }
        return true;
    });
    $('body').on('click', function (e) {
        $('[data-toggle="popover"]').each(function () {
            //the 'is' for buttons that trigger popups
            //the 'has' for icons within a button that triggers a popup
            if (!$(this).is(e.target) && $(this).has(e.target).length === 0 && $('.popover').has(e.target).length === 0) {
                $(this).popover('hide');
            }
        });
    });

};


var drawTable2 = function () {
    var max = 31;
    var calc = 0;
    for (var month in DATA) {
        if (month !== 'sum') {
            calc = parseInt(DATA[month]['length']) + parseInt(DATA[month]['1']['day'] - 1);
            if (calc > max)
                max = calc;
            calc = 0;
        }
    }
    var today = new Date();
    var dd = today.getDate();
    var mm = today.getMonth() + 1;
    var rr = today.getFullYear();
    var container = $('#tableContainer');
    var table = $('<table></table>');
    var row = $('<tr></tr>');
    var thead = $('<thead></thead>');
    var tbody = $('<tbody></tbody>');
    var th = '<th></th>';
    var cell = '<td></td>';
    container.html(table.addClass('table-userTable'));
    table.append(thead);
    thead.append(row);
    row.append($(th).html('Miesiąc'));
    var arr = [
        'Pn',
        'Wt',
        'Śr',
        'Cz',
        'Pt',
        'So',
        'Nd'
    ];
    for (var i = 0; i < max; i++) {
        row.append($(th).html(arr[i % 7]).addClass('days'));
    }
    row.append($(th).html('RCP')
            .addClass('rcp')
            .addClass('ex')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Przepracowanych godzin (RCP)')
            );
    row.append($(th).html('U')
            .addClass('summary')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Urlopy (U)')
            );
    row.append($(th).html('Ch')
            .addClass('summary')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Choroby (Ch)')
            );
    row.append($(th).html('RG')
            .addClass('summary')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Razem zarejestrowanch godzin (RCP+U+Ch)')
            );
    row.append($(th).html('DP')
            .addClass('summary')
            .addClass('ex')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Do przepracowania godzin (N-U-Ch)')
            );
    row.append($(th).html('N')
            .addClass('summary')
            .attr('data-viewport', '#tableContainer')
            .attr('data-container', 'body')
            .attr('rel', 'tooltip')
            .attr('data-original-title', 'Norma pracy (N)')
            );
    table.append(tbody);
    row = '<tr></tr>';
    var j = 1;
    for (var month in DATA) {

        var row_ = $(row);
        if (month === 'sum') 
            monthName = 'Razem';
        else
            monthName = month;
        row_.append($(cell).html(monthName).addClass('month'));
        if (month !== 'sum') {
            for (var i = 0; i < (parseInt(DATA[month]['1']['day']) - 1); i++) {
                var cell_ = $(cell).addClass('empty').addClass('days');
                row_.append(cell_);
            }
        } else {
            for (var i = 0; i < max; i++) {
                var cell_ = $(cell).addClass('empty').addClass('days');
                if (month === 'sum')
                    cell_.addClass('no-border');
                row_.append(cell_);

            }
        }
        if (month !== 'sum') {
            for (var i = 1; i <= (max - (parseInt(DATA[month]['1']['day']) - 1)); i++) {
                var cell_ = $(cell);
                if (i in DATA[month]) {
                    cell_.css('background-color', DATA[month][i]['color']);
                    cell_.attr('day', i);
                    cell_.attr('month', j);

                    if (i === dd && j === mm && YEAR == rr) {
                        cell_.addClass('today');
                    }
                    cell_.addClass('days');
                    cell_.css('cursor', 'pointer');
                    if (DATA[month][i]['eventsCount'] === 1) {
                        var text = DATA[month][i]['events']['text'];
                        cell_.html('<div style="height:15px; font-size:10px; border-bottom: 1px solid #303030;" class="workPattern"></div><div style="height:15px; " class="workEvents">' + text + '</div>');
                    }
                    if (DATA[month][i]['eventsCount'] > 1) {
                        cell_.css('font-size', '1.1em');
                        cell_.css('background-color', 'white');
                        var text = '<i class="fa fa-tags" aria-hidden="true"></i>';
                        cell_.html('<div style="height:15px; font-size:10px; border-bottom: 1px solid #303030;" class="workPattern"></div><div style="height:15px; " class="workEvents">' + text + '</div>');

                    }
                    if (DATA[month][i]['eventsCount'] === 0) {
                        cell_.addClass('days').html('<div style="height:31px; font-size:10px;" class="workPattern"></div');

                    }
                } else {
                    cell_.addClass('empty').addClass('days').html('<div style="height:31px; font-size:10px;" class="workPattern"></div');
                }
                row_.append(cell_);
            }
        }
        if (month === 'sum'){
            row_.addClass('sum');
            j = 'sum';
        }
        row_.append($(cell).html(DATA[month]['rcp']).addClass('rcp').addClass('ex').attr('id',j+'_rcp'));
        row_.append($(cell).html(DATA[month]['u']).addClass('summary').attr('id',j+'_u'));
        row_.append($(cell).html(DATA[month]['ch']).addClass('summary').attr('id',j+'_ch'));
        row_.append($(cell).html(DATA[month]['rg']).addClass('summary').css('background-color', 'lightblue').attr('id',j+'_rg'));
        row_.append($(cell).html(DATA[month]['dp']).addClass('summary').addClass('ex').css('background-color', 'lightblue').attr('id',j+'_dp'));
        row_.append($(cell).html(DATA[month]['n']).addClass('summary').attr('id',j+'_n'));
        j++;
        tbody.append(row_);
    }
    popover();
    filterColumns();
};

var TimeToHHMM = function (time) {
    var hours = (Math.floor(time / 3600)).toString().padStart(2, "0");
    var minutes = (Math.floor((time - hours * 3600)/60)).toString().padStart(2, "0");
    var formattedTime = (hours + ':' + minutes);
    return formattedTime;
};

var getSecondsFromString = function (str){
    var regex = /\d{1,}:/;
    var hours;
    hours = regex.exec(str);
    hours = hours[0].replace(':','');
    seconds = 0;
    seconds += hours * 3600;
    var regex = /:\d{1,}/;
    var minutes;
    minutes = regex.exec(str);
    minutes = minutes[0].replace(':','');
    seconds += minutes * 60;
    return seconds;
}