<?php

class PlacePdf extends EPdfFactoryDoc {

	public $pname = null;

	public function init()
    {
        //$this->setTemplate('template-outlines.pdf', 0, 0, 148); //with defining the area to print in
        //override the configured default
        $this->setTcpdfOptions(array('orientation'=>'P','format'=>'A4'));
    }

    // the pdf name on creating the (cached) file or downloading.
    //always add the extension '.pdf'
    public function getPdfName()
    {
		$kadrid = User::model()->findByAttributes(array('uid'=>Yii::app()->user->getId()));//Yii::app()->user->getState('kadrid');
		$this->pname = iconv('utf-8','cp1250','pasek_wynagrodzenia_'.$kadrid->nazwisko.'_'.$kadrid->imie.'_'.date("Y-m-d-H-i-s").'.pdf');
        return $this->pname;
    }

    // the info assigned to the pdf document
    protected function initDocInfo()
    {
        $pdf = $this->getPdf();
		$path = Firma::model()->findByPk(1)->drive_local;
		$path .= '/'.KadryPracownicy::model()->userDir(null, Yii::app()->user->getId());
		$path .= '/Place/Listy_plac/';
		$path = str_replace('\\','/',$path);
		$path = str_replace('/','\\',$path);
		Yii::app()->pdfFactory->setPdfPath($path);
        $pdf->SetTitle('Pasek wynagrodzenia');
        $pdf->SetSubject('Pasek wynagrodzenia');
        $pdf->SetKeywords('Pasek wynagrodzenia');
    }

    public function renderPdf()
    {
        $this->addPage();
        $pdf = $this->getPdf();
		$pdf->SetFont('myriadpro', '', 9);

        $firma = $this->getDataItem('firma');
		$user = $this->getDataItem('user');
		$names = $this->getDataItem('names');
		$totals = $this->getDataItem('totals');
		$zeros = $this->getDataItem('zeros');
		$zakres = $this->getDataItem('zakres');
		$cnt = 0;

		$pdf->SetMargins(8, 8, 8);
		$pdf->SetHeaderMargin(0);
		$pdf->SetFooterMargin(0);
		$pdf->setPrintFooter(false);
		$pdf->SetAutoPageBreak(TRUE, 0);

		$pdf->SetFontSize(12);
		$pdf->SetXY(8,10,true);
		$pdf->Cell(30, 0, $firma['nazwa'], 0);
		$pdf->SetFontSize(9);
		if (!empty($firma['ulica'])) {
			$pdf->SetXY(8,15,true);
			$pdf->Cell(40, 0, $firma['ulica'].' '.$firma['nrdomu'].'/ '.$firma['nrlok'], 0);
			$pdf->SetXY(8,19,true);
			$pdf->Cell(40, 0, $firma['kod'].' '.$firma['miasto'], 0);
		}
		$pdf->SetXY(8,23,true);
		$pdf->Cell(40, 0, 'NIP: '.$firma['nip'], 0);

		$pdf->SetFontSize(12);
		$pdf->SetXY(130,10,true);
		$pdf->Cell(50, 0, $user->imie.' '.$user->nazwisko, 0);
		$pdf->SetFontSize(10);
		$pdf->SetXY(130,15,true);
		$pdf->Cell(50, 0, 'Wynagrodzenie za okres od '.$zakres['rok'].'-'.$zakres['mod'].' do '.$zakres['rok'].'-'.$zakres['mdo'], 0);

		$pdf->SetXY(8,30,true);
		$pdf->SetFontSize(9);

		$tbl = '<style>
				.table-bordered {
					border: 1px solid #dddddd;
					color: black;
					font-size:9pt;
				}
				.table-bordered th {
				  border: 1px solid #005580;
				  color: white;
				  padding:5px;
				  background-color: #49afcd;
				  font-weight: bold;
				}
				.table-bordered td {
				  border: 1px solid #dddddd;
				  padding:5px;
				}
				</style><table class="table-bordered" cellpadding="2"><thead><tr><th style="width:70%">Nazwa Elementu</th><th style="width:30%">Wartość (zł)</th></tr></thead>';
					foreach($names as $eid => $nazwa) {
						if ($totals[$eid] > 0 OR ($zeros[$eid] == 1 and ($totals[$eid] == 0 or empty($totals[$eid])))) {
							$tbl .= '<tr><td style="width:70%">'.$nazwa.'</td><td style="width:30%"><b>'.number_format($totals[$eid], 2, ".", "").'</b></td></tr>';
							$cnt = $cnt + 1;
						}
					}
		$tbl .= '</table><br>
				<br>Data wystawienia dokumentu: '.date("Y-m-d").'<br>
				Wygenerowany elektronicznie pasek wynagrodzeń.<br>
				Nie wymaga podpisu ani stempla.';

		$pdf->writeHTML($tbl, true, false, false, false, '');

    }
}