<?php

    class PresenceList extends EPdfFactoryDoc
    {

        const textStatus = [	
        '0' => 'Nieobecny',
        '1' => 'Obecny',
        '2' => 'Po pracy',
        '3' => 'Brak zapisów'];

        public function init()
        {
            $this->setTcpdfOptions(array('orientation' => 'P', 'format' => 'A4'));
        }

        public function getData(){
            $presenceList = $this->getDataItem('preparedList');
            return $presenceList;
        }
        
        public function getPdfName()
        {

            $this->pname = 'Lista_Obecności_' . date("Y-m-d-H-i-s") . '.pdf';
            return $this->pname;
        }
    
        public function initDocInfo()
        {
            $pdf = $this->getPdf();

            $pdf->SetTitle('Lista Obecności na'. date('Y-m-d-H-i'));
            $pdf->SetSubject('Lista Obecności na'. date('Y-m-d-H-i'));
            $pdf->SetKeywords('Lista Obecności na dzień');
        }

        public function renderPdf()
        {
            $this->addPage();
            $this->initMargins();
            $this->initFooter();
            $pdf = $this->getPdf();
            $pdf->SetFont('myriadpro', '', 9);

            $pdf->SetHeaderMargin(0);
            $pdf->SetFooterMargin(0);
            $pdf->setPrintFooter(true);
            $users = $this->getData();
    
            $html = $this->createReport($users);
            
            $pdf->writeHTML($html, false, false, false, false, '');


        }

        public function createReport($users){
            $tbl = '
            <style>
                table{
                    width: 100%;
                    border-collapse: collapse;
                }
                
                td {
                    padding-top: 15px;
                    padding-bottom: 15px;
                    text-align: left;
                    border-bottom: 0.5px solid #e6e6e6;
                }
        
                th {
                    text-align: left;
                    padding: 10px;
                    border-bottom: 0.5px solid #e6e6e6;
                    font-size: 1.4em;
                    padding-top: 15px;
                    padding-bottom: 15px;
                }
                
                tr{
                    height: 120%
                }

                p{
                    text-align: center;
                    font-size: 1.8em;
                }
            </style>

            <p>
                Lista obecności 18.05.2018 11:35
            </p>
            <table>
                <tr>
                    <th>Pracownik</th>
                    <th>Obecność</th>
                </tr>';
            
            foreach ($users as $fullname => $presence){
                $tbl .= '<tr><td>'.$fullname.'</td>
                    <td>'.self::textStatus[$presence].'</td></tr>';
            }
            $tbl.= '</table>';

            return $tbl;

        }
    }

?>