<?php class StanPdf extends EPdfFactoryDoc {

	public $pname = null;

	public function init()
    {
        //$this->setTemplate('template-outlines.pdf', 0, 0, 148); //with defining the area to print in
        //override the configured default
        $this->setTcpdfOptions(array('orientation'=>'P','format'=>'A4'));
    }

    // the pdf name on creating the (cached) file or downloading.
    //always add the extension '.pdf'
    public function getPdfName()
    {
		$this->pname = 'wniosek_dane_osobowe_'.date("Y-m-d-H-i-s").'.pdf';
        return $this->pname;
    }

    // the info assigned to the pdf document
    protected function initDocInfo()
    {
        $pdf = $this->getPdf();

        $pdf->SetTitle('Wniosek zmiany danych osobowych');
        $pdf->SetSubject('Wniosek zmiany danych osobowych');
        $pdf->SetKeywords('Wniosek zmiany danych osobowych');
    }

    public function renderPdf()
    {
        $this->addPage();
        $pdf = $this->getPdf();
		$pdf->SetFont('myriadpro', '', 9);

        $pracownik = $this->getDataItem('pracownik');
		$adresy = $this->getDataItem('adresy');
		$wniosek = $this->getDataItem('wniosek');
		$labels = $this->getDataItem('labels');

		$pdf->SetMargins(8, 8, 8);
		$pdf->SetHeaderMargin(0);
		$pdf->SetFooterMargin(0);
		$pdf->setPrintFooter(false);
		$pdf->SetAutoPageBreak(TRUE, 0);

		$tbl = 'style>
	.table-bordered {
		width: 100%;
		border: 1px solid #dddddd;
		color: black;
		font-size:12pt;
		max-width: 1200px;
		margin:auto;
	}
	.table-bordered td {
		border: 1px solid #dddddd;
		padding:2px;
		min-width:20px;
		max-width:20px;
	}
	.table-bordered td a {
		color: black;
	}
	#user {
		font-size:10pt;

		border: 1px solid #dddddd;
		padding:2px;

		font-size:10pt;
		overflow:visible;
	}
	h3 {
		color: #49afcd;
	}
</style>
					<h1>Wniosek zmiany danych osobowych</h1>
					<table class="container">
						<tr>
							<td>
								<h3>Dane istniejące</h3>
								<table class="table-bordered" cellpadding="1">
										<tr>
											<td class="label">
												'.$labels['imie1'].'
											</td>

											<td>
												'.$pracownik['imie1'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['imie2'].'
											</td>

											<td>
												'.$pracownik['imie2'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['nazwisko'].'
											</td>

											<td>
												'.$pracownik['nazwisko'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['email_pracownika'].'
											</td>

											<td>
												'.$pracownik['email_pracownika'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['telefon_sluzbowy'].'
											</td>

											<td>
												'.$pracownik['telefon_sluzbowy'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['telefon_prywatny'].'
											</td>

											<td>
												'.$pracownik['telefon_prywatny'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['telefon_komorkowy'].'
											</td>

											<td>
												'.$pracownik['telefon_komorkowy'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['dokument_tozsamosci'].'
											</td>

											<td>
												'.$pracownik['Dokument_tozsamosci'].'
											</td>
										</tr>

										<tr>
											<td class="label">
												'.$labels['nr_seria_dowodu_tozsamosci'].'
											</td>

											<td>
												'.$pracownik['nr_seria_dowodu_tozsamosci'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['dowod_tozsamosci_wydany_przez'].'
											</td>

											<td>
												'.$pracownik['dowod_tozsamosci_wydany_przez'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['osoba_dp_imie'].'
											</td>

											<td>
												'.$pracownik['osoba_do_powiadomienia_imie'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['osoba_dp_nazwisko'].'
											</td>

											<td>
												'.$pracownik['osoba_do_powiadomienia_nazwisko'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['osoba_dp_telefon'].'
											</td>

											<td>
												'.$pracownik['osoba_do_powiadomienia_telefon'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['osoba_dp_adres'].'
											</td>

											<td>
												'.$pracownik['osoba_do_powiadomienia_adres'].'
											</td>
										</tr>
								</table>
							</td>

							<td>
								<h3>Dane do zmiany</h3>
								<table class="table-bordered" cellpadding="1">
										<tr>
											<td class="label">
												'.$labels['imie1'].'
											</td>

											<td>
												'.$wniosek['imie1'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['imie2'].'
											</td>

											<td>
												'.$wniosek['imie2'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['nazwisko'].'
											</td>

											<td>
												'.$wniosek['nazwisko'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['email_pracownika'].'
											</td>

											<td>
												'.$wniosek['email_pracownika'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['telefon_sluzbowy'].'
											</td>

											<td>
												'.$wniosek['telefon_sluzbowy'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['telefon_prywatny'].'
											</td>

											<td>
												'.$wniosek['telefon_prywatny'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['telefon_komorkowy'].'
											</td>

											<td>
												'.$wniosek['telefon_komorkowy'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['dokument_tozsamosci'].'
											</td>

											<td>
												'.$wniosek['dokument_tozsamosci'].'
											</td>
										</tr>

										<tr>
											<td class="label">
												'.$labels['nr_seria_dowodu_tozsamosci'].'
											</td>

											<td>
												'.$wniosek['nr_seria_dowodu_tozsamosci'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['dowod_tozsamosci_wydany_przez'].'
											</td>

											<td>
												'.$wniosek['dowod_tozsamosci_wydany_przez'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['osoba_dp_imie'].'
											</td>

											<td>
												'.$wniosek['osoba_dp_imie'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['osoba_dp_nazwisko'].'
											</td>

											<td>
												'.$wniosek['osoba_dp_nazwisko'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['osoba_dp_telefon'].'
											</td>

											<td>
												'.$wniosek['osoba_dp_telefon'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['osoba_dp_adres'].'
											</td>

											<td>
												'.$wniosek['osoba_dp_adres'].'
											</td>
										</tr>
								</table>
							</td>
						</tr>

						<tr>
							<td>
							<br>
								<h3>Adres zameldowania</h3>
								<table class="table-bordered" cellpadding="1">
										<tr>
											<td class="label">
												'.$labels['zam_ulica'].'
											</td>

											<td>
												'.$adresy['zameldowanie']['ulica'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_nrdom'].'
											</td>

											<td>
												'.$adresy['zameldowanie']['nr_domu'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_nrlok'].'
											</td>

											<td>
												'.$adresy['zameldowanie']['nr_lokalu'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_kod'].'
											</td>

											<td>
												'.$adresy['zameldowanie']['kod_pocztowy'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_miejscowosc'].'
											</td>

											<td>
												'.$adresy['zameldowanie']['miejscowosc'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_poczta'].'
											</td>

											<td>
												'.$adresy['zameldowanie']['poczta'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_gmina'].'
											</td>

											<td>
												'.$adresy['zameldowanie']['gmina'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_powiat'].'
											</td>

											<td>
												'.$adresy['zameldowanie']['powiat'].'
											</td>
										</tr>

										<tr>
											<td class="label">
												'.$labels['zam_wojew'].'
											</td>

											<td>
												'.$adresy['zameldowanie']['wojewodztwo'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_kraj'].'
											</td>

											<td>
												'.$adresy['zameldowanie']['kraj'].'
											</td>
										</tr>
								</table>
							</td>

							<td><br>
								<h3>Adres zameldowania</h3>
								<table class="table-bordered" cellpadding="1">
																			<tr>
											<td class="label">
												'.$labels['zam_ulica'].'
											</td>

											<td>
												'.$wniosek['zam_ulica'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_nrdom'].'
											</td>

											<td>
												'.$wniosek['zam_nrdom'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_nrlok'].'
											</td>

											<td>
												'.$wniosek['zam_nrlok'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_kod'].'
											</td>

											<td>
												'.$wniosek['zam_kod'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_miejscowosc'].'
											</td>

											<td>
												'.$wniosek['zam_miejscowosc'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_poczta'].'
											</td>

											<td>
												'.$wniosek['zam_poczta'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_gmina'].'
											</td>

											<td>
												'.$wniosek['zam_gmina'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_powiat'].'
											</td>

											<td>
												'.$wniosek['zam_powiat'].'
											</td>
										</tr>

										<tr>
											<td class="label">
												'.$labels['zam_wojew'].'
											</td>

											<td>
												'.$wniosek['zam_wojew'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['zam_kraj'].'
											</td>

											<td>
												'.$wniosek['zam_kraj'].'
											</td>
										</tr>
								</table>
							</td>
						</tr>
						<tr>
							<td><br>
								<h3>Adres tymczasowy</h3>
								<table class="table-bordered" cellpadding="1">
										<tr>
											<td class="label">
												'.$labels['tym_ulica'].'
											</td>

											<td>
												'.$adresy['tymczasowy']['ulica'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_nrdom'].'
											</td>

											<td>
												'.$adresy['tymczasowy']['nr_domu'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_nrlok'].'
											</td>

											<td>
												'.$adresy['tymczasowy']['nr_lokalu'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_kod'].'
											</td>

											<td>
												'.$adresy['tymczasowy']['kod_pocztowy'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_miejscowosc'].'
											</td>

											<td>
												'.$adresy['tymczasowy']['miejscowosc'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_poczta'].'
											</td>

											<td>
												'.$adresy['tymczasowy']['poczta'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_gmina'].'
											</td>

											<td>
												'.$adresy['tymczasowy']['gmina'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_powiat'].'
											</td>

											<td>
												'.$adresy['tymczasowy']['powiat'].'
											</td>
										</tr>

										<tr>
											<td class="label">
												'.$labels['tym_wojew'].'
											</td>

											<td>
												'.$adresy['tymczasowy']['wojewodztwo'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_kraj'].'
											</td>

											<td>
												'.$adresy['tymczasowy']['kraj'].'
											</td>
										</tr>
								</table>
							</td>

							<td><br>
								<h3>Adres tymczasowy</h3>
								<table class="table-bordered" cellpadding="1">
										<tr>
											<td class="label">
												'.$labels['tym_ulica'].'
											</td>

											<td>
												'.$wniosek['tym_ulica'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_nrdom'].'
											</td>

											<td>
												'.$wniosek['tym_nrdom'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_nrlok'].'
											</td>

											<td>
												'.$wniosek['tym_nrlok'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_kod'].'
											</td>

											<td>
												'.$wniosek['tym_kod'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_miejscowosc'].'
											</td>

											<td>
												'.$wniosek['tym_miejscowosc'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_poczta'].'
											</td>

											<td>
												'.$wniosek['tym_poczta'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_gmina'].'
											</td>

											<td>
												'.$wniosek['tym_gmina'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_powiat'].'
											</td>

											<td>
												'.$wniosek['tym_powiat'].'
											</td>
										</tr>

										<tr>
											<td class="label">
												'.$labels['tym_wojew'].'
											</td>

											<td>
												'.$wniosek['tym_wojew'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['tym_kraj'].'
											</td>

											<td>
												'.$wniosek['tym_kraj'].'
											</td>
										</tr>
								</table>
							</td>
						</tr>
						<tr>
							<td><br>
								<h3>Adres korespondencyjny</h3>
								<table class="table-bordered" cellpadding="1">
										<tr>
											<td class="label">
												'.$labels['kor_ulica'].'
											</td>

											<td>
												'.$adresy['korespondencja']['ulica'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_nrdom'].'
											</td>

											<td>
												'.$adresy['korespondencja']['nr_domu'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_nrlok'].'
											</td>

											<td>
												'.$adresy['korespondencja']['nr_lokalu'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_kod'].'
											</td>

											<td>
												'.$adresy['korespondencja']['kod_pocztowy'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_miejscowosc'].'
											</td>

											<td>
												'.$adresy['korespondencja']['miejscowosc'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_poczta'].'
											</td>

											<td>
												'.$adresy['korespondencja']['poczta'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_gmina'].'
											</td>

											<td>
												'.$adresy['korespondencja']['gmina'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_powiat'].'
											</td>

											<td>
												'.$adresy['korespondencja']['powiat'].'
											</td>
										</tr>

										<tr>
											<td class="label">
												'.$labels['kor_wojew'].'
											</td>

											<td>
												'.$adresy['korespondencja']['wojewodztwo'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_kraj'].'
											</td>

											<td>
												'.$adresy['korespondencja']['kraj'].'
											</td>
										</tr>
								</table>
							</td>

							<td><br>
								<h3>Adres korespondencyjny</h3>
								<table class="table-bordered" cellpadding="1">
																			<tr>
											<td class="label">
												'.$labels['kor_ulica'].'
											</td>

											<td>
												'.$wniosek['kor_ulica'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_nrdom'].'
											</td>

											<td>
												'.$wniosek['kor_nrdom'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_nrlok'].'
											</td>

											<td>
												'.$wniosek['kor_nrlok'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_kod'].'
											</td>

											<td>
												'.$wniosek['kor_kod'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_miejscowosc'].'
											</td>

											<td>
												'.$wniosek['kor_miejscowosc'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_poczta'].'
											</td>

											<td>
												'.$wniosek['kor_poczta'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_gmina'].'
											</td>

											<td>
												'.$wniosek['kor_gmina'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_powiat'].'
											</td>

											<td>
												'.$wniosek['kor_powiat'].'
											</td>
										</tr>

										<tr>
											<td class="label">
												'.$labels['kor_wojew'].'
											</td>

											<td>
												'.$wniosek['kor_wojew'].'
											</td>
										</tr>
										<tr>
											<td class="label">
												'.$labels['kor_kraj'].'
											</td>

											<td>
												'.$wniosek['kor_kraj'].'
											</td>
										</tr>
								</table>
							</td>
						</tr>
					</table>
					<br>
					<br>
					<br>
					<br>';
					$pdf->writeHTML($tbl, true, false, false, false, '');
		$pdf->SetFontSize(9);
		$pdf->SetXY(130,265,true);
		$pdf->Cell(50, 0, '...........................................................................................................', 0);
		$pdf->SetXY(142,270,true);
		$pdf->Cell(50, 0, 'data i podpis składającego wniosek', 0);

    }
}