<?php class WniosekPdf extends EPdfFactoryDoc {

	public function init()
    {
        $this->setTemplate('template-outlines.pdf', 0, 0, 148); //with defining the area to print in
        //override the configured default
        //$this->setTcpdfOptions(array('orientation'=>'L', ...);
    }

    // the pdf name on creating the (cached) file or downloading.
    //always add the extension '.pdf'
    public function getPdfName()
    {
		$data = $this->getDataItem('model');
        return 'wniosek_'.$data['typ'].'_'.$data['id'].'.pdf';
    }

    // the info assigned to the pdf document
    protected function initDocInfo()
    {
        $pdf = $this->getPdf();
		$model = $this->getDataItem('model');
		$path = Firma::model()->findByPk(1)->drive_local;
		$path .= '/'.KadryPracownicy::model()->userDir(null, $model['userid']);
		$path .= '/e-Teczka/B_w_trakcie_zatrudnienia/';
		$path = str_replace('\\','/',$path);
		$path = str_replace('/','\\',$path);
		Yii::app()->pdfFactory->setPdfPath($path);
        $pdf->SetTitle('Wydruk wniosku');
        $pdf->SetSubject('Wydruk wniosku');
        $pdf->SetKeywords('urlop, wniosek');
    }

    public function renderPdf()
    {
        $this->addPage();
        $pdf = $this->getPdf();
		$pdf->SetFont('myriadpro', '', 9);
        $model = $this->getDataItem('model');
		$pdf->SetMargins(0, 0, 0);
		$pdf->SetHeaderMargin(0);
		$pdf->SetFooterMargin(0);
		$pdf->setPrintFooter(false);
		$pdf->SetAutoPageBreak(TRUE, 0);

		$pdf->SetXY(13,10,true);
        $pdf->SetFontSize(9);
		$pdf->Cell(30, 0, $model['miasto'], 0);

		$pdf->SetXY(101.5,10,true);
		$pdf->SetFontSize(12);
		$pdf->Cell(9.5, 0, $model['dayc'], 0);
		$pdf->Cell(14.5, 0, $model['monthc'], 0);
		$pdf->Cell(8, 0, $model['yearc'], 0);

		$pdf->SetXY(26,18,true);
        $pdf->SetFontSize(9);
		$pdf->Cell(80, 0, $model['imienaz'], 0);
		$pdf->SetXY(26,24.5,true);
		$pdf->Cell(60, 0, $model['stanowisko'], 0);

		$pdf->SetXY(46,32,true);
		$pdf->Cell(90, 0, $model['typ'], 0);

		$pdf->SetXY(21,40.5,true);
		$pdf->SetFontSize(12);
		$pdf->Cell(7.5, 0, $model['day1'], 0);
		$pdf->Cell(12.5, 0, $model['month1'], 0);
		$pdf->Cell(6, 0, $model['year1'], 0);

		$pdf->SetXY(60.5,40.5,true);
		$pdf->Cell(7.5, 0, $model['day2'], 0);
		$pdf->Cell(12.5, 0, $model['month2'], 0);
		$pdf->Cell(6, 0, $model['year2'], 0);

		$pdf->SetXY(122,40.5,true);
        $pdf->Cell(9, 0, $model['udni'], 0);
        $pdf->Cell(6, 0, $model['ugodzin'], 0);

		$pdf->SetXY(30,47,true);
        $pdf->SetFontSize(9);
		$pdf->Cell(105, 0, $model['uzasadnienie'], 0);

		$pdf->SetXY(27,93,true);
        $pdf->Cell(10.5, 0, $model['udni'], 0);
        $pdf->Cell(17, 0, $model['ugodzin'], 0);
        $pdf->Cell(55, 0, $model['typ'], 0);
    }
}