<?php class WniosekViewPdf extends EPdfFactoryDoc {

	public $pname = NULL;

	public function init() {
		//$this->setTemplate('template-outlines.pdf', 0, 0, 148); //with defining the area to print in
		//override the configured default
		$this->setTcpdfOptions( array( 'orientation' => 'P', 'format' => 'A4' ) );
	}

	// the pdf name on creating the (cached) file or downloading.
	//always add the extension '.pdf'
	public function getPdfName() {
		$this->pname = 'wniosek_' . date( "Y-m-d-H-i-s" ) . '.pdf';
		return $this->pname;
	}

	// the info assigned to the pdf document
	protected function initDocInfo() {
		$pdf = $this->getPdf();

		$pdf->SetTitle( 'Wniosek' );
		$pdf->SetSubject( 'Wniosek' );
		$pdf->SetKeywords( 'Wniosek' );
	}

	public function renderPdf() {
		$this->addPage();
		$pdf = $this->getPdf();
		$pdf->SetFont( 'myriadpro', '', 11 );

		$model = $this->getDataItem( 'model' );


		$pdf->SetMargins( 8, 8, 8 );
		$pdf->SetHeaderMargin( 0 );
		$pdf->SetFooterMargin( 0 );
		$pdf->setPrintFooter( FALSE );
		$pdf->SetAutoPageBreak( TRUE, 0 );

		$tbl = '<style>
					.table-bordered {
						width: 100%;
						border: 1px solid #dddddd;
						color: black;
						font-size:12pt;
						max-width: 1200px;
						margin:auto;
					}
					.table-bordered td {
						border: 1px solid #dddddd;
						padding:2px;
						min-width:20px;
						max-width:20px;
					}
					.table-bordered td a {
						color: black;
					}
					#user {
						font-size:10pt;
				
						border: 1px solid #dddddd;
						padding:2px;
				
						font-size:10pt;
						overflow:visible;
					}
					h3 {
						color: #49afcd;
					}
				</style>
					<h1>Wniosek ' . $model[ 'user' ] . '</h1>

								<table class="table-bordered" cellpadding="1">
										<tr>
											<td class="label">
												Rodzaj
											</td>

											<td>
												' . $model[ 'rodzaj' ] . '
											</td>
										</tr>
										<tr>
											<td class="label">
												Utworzony
											</td>

											<td>
												' . $model[ 'created' ] . '
											</td>
										</tr>
										<tr>
											<td class="label">
												Od
											</td>

											<td>
												' . $model[ 'od' ] . '
											</td>
										</tr>
										<tr>
											<td class="label">
												Do
											</td>

											<td>
												' . $model[ 'do' ] . '
											</td>
										</tr>
										<tr>
											<td class="label">
												Rodzaj
											</td>

											<td>
												' . $model[ 'rodzaj' ] . '
											</td>
										</tr>
										<tr>
											<td class="label">
												Status
											</td>

											<td>
												' . $model[ 'status' ] . '
											</td>
										</tr>
										<tr>
											<td class="label">
												Uzasadnienie
											</td>

											<td>
												' . $model[ 'uwagi' ] . '
											</td>
										</tr>
										<tr>
											<td class="label">
												Akceptacja
											</td>

											<td>
												' . $model[ 'akceptacja' ] . '
											</td>
										</tr>
								</table>
						
					<br>
					<br>
					<br>
					<br>';
		$pdf->writeHTML( $tbl, TRUE, FALSE, FALSE, FALSE, '' );
		$pdf->SetFontSize( 9 );
		$pdf->SetXY( 130, 265, TRUE );
		$pdf->Cell( 50, 0, '...........................................................................................................', 0 );
		$pdf->SetXY( 142, 270, TRUE );
		$pdf->Cell( 50, 0, 'data i podpis składającego wniosek', 0 );

	}
}